c------------------------------------
      Subroutine Template
      include 'ful0.inc'
      include 'ful1.inc'
      include 'ful2.inc'
      character ans*1
      icomm=1
      write(*,'(a)')
     + ' => Create standard template (s=<cr>) or detailed *.pcr (d): '
      read(*,'(a)') ans
c--------------------------------------
      if(ans.eq.'d'.or.ans.eq.'D') then
c--------------------------------------
        call Stop_cond(' Sorry!, option not available yet.',1)
c--------------------------------------
       else
c--------------------------------------

      write(*,'(a/a/a)') ' => Options: ',
     + '              (1) Simple X-ray powder diffraction ',
     + '              (2) Neutrons + magnetic structure'
      write(*,'(a,$)') ' => Enter option: '
      read(*,'(a)') ans
      if(ans.eq.'1') then
      title=
     +'  Template File ''starting.pcr'': Calculation pattern of CeO2  '
       JOBTYP=2
       IDUM=1
       GLB(2)=200.00
       PAR(1,1)=1.0e-05
       PAR(1,2)=0.0
       PAR(1,3)= 0.00783
       PAR(1,4)=-0.00788
       PAR(1,5)= 0.00943
       alow(1)=0.0
       ahigh(1)=3.0
       alow(2)=175.0
       ahigh(2)=180.0
       PAR(1,17)=0.45   !eta
       PAR(1,14)=0.021  !asymmetry
       PHSNM(1)= ' CeO2 (X-ray diffraction) Cu-Kalpha'
       natom(1)=2
       ATEXT(1)='Ce  '
       NTYP(1)='CE  '
       ATEXT(2)='O   '
       NTYP(2)='O   '
         XL(1,4)=0.39
         XL(1,5)=0.125
       do j=1,3
         XL(2,j)=0.25
       end do
         XL(2,4)=0.96
         XL(2,5)=0.250
         SYMB(1,1)='F'
         SYMB(1,2)=' '
         SYMB(1,3)='m'
         SYMB(1,4)=' '
         SYMB(1,5)='3'
         SYMB(1,6)=' '
         SYMB(1,7)='m'

        else

      title=
     +'  Template File ''starting.pcr'': Ho2BaNiO5-Low temperature  '
       JOBTYP=3
       IDUM=0
       thmin=10.0
       thmax=90.0
       step=0.1
       NLines_text(1)=8
       Page_Text(1,1)='SYMM    X,Y,Z'
       Page_Text(1,2)='MSYM    U,V,W,0.0'
       Page_Text(1,3)='SYMM   -X,Y,-Z'
       Page_Text(1,4)='MSYM    U,V,W,0.0'
       Page_Text(1,5)='SYMM   -X,-Y,-Z'
       Page_Text(1,6)='MSYM    U,V,W,0.0 '
       Page_Text(1,7)='SYMM    X,-Y,Z'
       Page_Text(1,8)='MSYM    U,V,W,0.0'
       GLB(2)=7000.00
       lamda(1)=2.52
       lamda(2)=2.52
       ratio(2)=1.0
       cthm=0.0
       jbt(1)=10
       isym(1)=-1
       nvk(1)=1
       MLTG(1)=4
       ICET(1)=1
       NUMSPG(1)=1
       NMAGR(1)=1
       pvk(1,1,1)=0.5
       pvk(1,1,2)=0.0
       pvk(1,1,3)=0.5
       PAR(1,1)=930.0
       PAR(1,2)=0.0
       PAR(1,3)= 1.63075
       PAR(1,4)=-1.07796
       PAR(1,5)= 0.35968
       save(1,1)=  3.754824
       save(1,2)=  5.733367
       save(1,3)= 11.274480
       alow(1)=0.0
       ahigh(1)=10.0
       alow(2)=90.0
       ahigh(2)=180.0
       PAR(1,17)=0.03   !eta
       PAR(1,14)=0.02   !asymmetry
       PHSNM(1)= ' Ho2BaNiO5-Low temperature'
       natom(1)=6
       ATEXT(1)='Ba  '
       NTYP(1)='BA  '
       ATEXT(2)='Ho  '
       NTYP(2)='JHO3'
       imagr(2)=1
       N_t(2)=1
       ATEXT(3)='Ni  '
       NTYP(3)='MNI2'
       imagr(3)=1
       N_t(3)=1
       ATEXT(4)='O1  '
       NTYP(4)='O   '
       ATEXT(5)='O1p '
       NTYP(5)='O   '
       ATEXT(6)='O2  '
       NTYP(6)='O   '
         XL(1,1)=0.5
         XL(1,2)=0.5
         XL(1,3)=0.0
         XL(1,5)=0.125
         XL(2,1)=0.5
         XL(2,2)=0.0
         XL(2,3)=0.2026
         XL(2,4)=0.0
         XL(2,5)=0.250
         XL(2,6)=0.123
         XL(2,7)=0.0
         XL(2,8)=8.9
         XL(3,5)=0.125
         XL(3,6)=0.6
         XL(3,7)=-1.3
         XL(4,1)=0.0
         XL(4,2)=0.24367
         XL(4,3)=0.14909
         XL(4,4)=0.0
         XL(4,5)=0.25
         XL(5,1)=0.0
         XL(5,2)=0.24367
         XL(5,3)=-0.14909
         XL(5,4)=0.0
         XL(5,5)=0.25
         XL(6,1)=0.5
         XL(6,2)=0.0
         XL(6,3)=0.0
         XL(6,4)=0.0
         XL(6,5)=0.125
         SYMB(1,1)='I'
         SYMB(1,2)=' '
         SYMB(1,3)='-'
         SYMB(1,4)='1'
         SYMB(1,5)=' '
         SYMB(1,6)=' '
         SYMB(1,7)=' '
         par(1,2)=0.45

       endif ! x-rays or neutrons
c---------------------------------------------
      endif !Standard or detailed *.PCR file
c---------------------------------------------
      call rewrit(0,0,0.0,0.0)
      return
      end
C********1*********2*********3*********4*********5*********6*********7**
      SUBROUTINE REWRIT(ISCALE,IDIF,T1,T2)
C********1*********2*********3*********4*********5*********6*********7**
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
cfree
      Character    FMTformat*132
cfree
      Integer Mod6
      common/SymOpda/Mod6(36,3,3) !1->24 Oh, 25->36 D6h
      COMMON/FORMATO/INSTR,NUMOR,TSAMP
      common/R_bragg/R_braggs(NPHT)
      LOGICAL FERMIL,nomag
      LOGICAL read_bac
      DIMENSION IM(3,3),TS(3)
      if(NXT.eq.1) then
       REWIND i_pcr
       i5=i_pcr
      else
       Call Openfile(16,0,1)
       i5=i_new
      endif
      if(icomm.eq.1) then
        WRITE(I5,'(A,A70)')'COMM',TITLE
        lon1=lenstr(filedat)
        lon2=lenstr(filenam)
        WRITE(I5,'(a,a,a,a)')'! Files => DAT-file: ',filedat(1:lon1),
     +   ',  PCR-file: ',filenam(1:lon2)
      else
        WRITE(I5,'(A70)')TITLE
      endif
c     JOBTYP=JOBTYP-1
      NPROF=NPROF-1
      IF(ISBAC.EQ.-1) THEN
       NBAC=-NBCKGD
      ELSE
       NBAC=NBCKGD
      ENDIF
       read_bac=(NBCKGD.eq.1.AND.ISBAC.EQ.1).or.
     +          (NBCKGD.eq.2.AND.ISBAC.EQ.-1)
      IF(iasym.eq.1) THEN
      NPH=-NPHASE
       else
      NPH=NPHASE
      ENDIF
      if(icomm.eq.1) write(i5,'(a,a)')'!Job Npr Nph Nba Nex Nsc Nor Dum'
     +,' Iwg Ilo Ias Res Ste Nre Cry Uni Cor'
      WRITE(I5,2)JOBTYP,NPROF,NPH,NBAC,NEXCRG,NSCAT,NORI,IDUM,IWGT
     *,ILOR,IASG,IRESO,ISTEP,NRELL,ICRYG,IXUNIT,ICORR
      if(icomm.eq.1) write(i5,'(a)')'!'
      NSC=IABS(NSCAT)
   2  FORMAT(17I4)
      IF(IRESO.NE.0) WRITE(I5,'(A)') FILEres
      if(icomm.eq.1) write(i5,'(a,a)')'!Ipr Ppl Ioc Mat Pcr Ls1 Ls2 Ls3'
     +,' Syo Prf Ins Rpa Sym Hkl Fou Sho Ana'
         FmtFormat='(17I4)'
      WRITE(I5,Fmtformat)
     +  IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2,
     +  INSTR,JCIL,JSY,JLKH,JFOU,ISHOR,IANALY
      if(icomm.eq.1) write(i5,'(a)')'!'
      if(iuvw.eq.1) ratio(2)=-ratio(2)
      if(ICRYG.eq.0) then
       if(icomm.eq.1) write(i5,'(a,a)')'! lambda1 Lambda2    Ratio',
     +'   Bkpos    Wdt    Cthm     muR   AsyLim   Rpolarz'
       WRITE(I5,23)LAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,RKK
      if(icomm.eq.1) write(i5,'(a)')'!'
      endif
  23  FORMAT(2F9.6,5F8.4,f8.2,1x,f9.4)
         FmtFormat='(I3,1X,5(F4.2,1X),3f11.4,2F8.3)'
       if(icomm.eq.1) write(i5,'(a,a)')'!NCY Eps R_at R_an R_pr R_gl',
     + '     Thmin       Step       Thmax    PSD    Sent0'
      WRITE(I5,FmtFormat)MCYCLE,EPS,RELAX,THMIN,STEP,THMAX,ALPSD,SENT0
      if(icomm.eq.1) write(i5,'(a)')'!'
      IF(ICRYG.NE.0) GOTO 122
      IF(NBCKGD.LT.2.or.read_bac)GOTO 120
      if(icomm.eq.1) write(i5,'(a)')'! 2Theta/TOF    Background'
      WRITE(I5,'(f8.2,1x,f12.2)')(POS(I),BCK(I),I=1,NBCKGD)
      if(icomm.eq.1) write(i5,'(a)')'! '
 344  FORMAT(F8.2,F8.0)
 120  IF(NEXCRG.LE.0)GOTO 122
      if(icomm.eq.1) write(i5,'(a)')'! Excluded regions (LowT  HighT)'
      WRITE(I5,'(2f12.2)')(ALOW(I),AHIGH(I),I=1,NEXCRG)
      if(icomm.eq.1) write(i5,'(a)')'! '
 122  IF(NSCAT.EQ.0) GOTO 124
C---------------------------------------------
      if(icomm.eq.1) write(i5,'(a)')'! Additional scattering factors '
      DO 125 I=1,NSC
      FERMIL=.FALSE.
      WRITE(I5,38)NAM(I),DFP(I),DFPP(I),ITY(I)
 38   FORMAT(A4,1x,F8.3,1x,f8.3,I4)
      IF(NSCAT.GT.0) THEN
       IF(JOBTYP.EQ.0.or.jobtyp.eq.2.OR.ITY(I).NE.0) then
        IF(ITY(I).NE.2)  WRITE(I5,39)(AC(J,I),J=1,9)
       endif
 39    FORMAT(8(F12.5,1x),f12.5)
      ELSE
       if(ITY(I).EQ.0.AND.(iabs(JOBTYP).EQ.1.OR.iabs(JOBTYP).EQ.3))
     +                FERMIL=.TRUE.
       DO K=1,NPSC(I)
        WRITE(I5,'(F8.3,1x,F12.5)') STAR(K,I),AC(K,I)
       END DO
       IF(.NOT.FERMIL) WRITE(I5,'(A)')'  -100.0'
      ENDIF
 125  CONTINUE
  124 CONTINUE
C---------------------------------------------
      if(icomm.eq.1) write(i5,'(a)')'!'
      WRITE(I5,'(i8,a)')MAXS,'    !Number of refined parameters'
      N=0
      DO IIPHAS=1,NPHASE
       N=N+NATOM(IIPHAS)
      end do
      DO I=1,N
       DO J=1,nat_p
         A(I,J)=SIGN(1.,A(I,J))*(FLOAT(10*LP(I,J))+ABS(A(I,J)))
       end do
      end do
      DO I=1,NPHASE
       DO J=1,6
        PAR(I,J+5)=SAVE(I,J)
       end do
       DO J=1,MPAR
       APAR(I,J)=SIGN(1.,APAR(I,J))*(FLOAT(10*LPAR(I,J))+ABS(APAR(I,J)))
       end do
      END DO

      DO  J=1,NGL
       AGLB(J)=SIGN(1.,AGLB(J))*(FLOAT(10*LGLB(J))+ABS(AGLB(J)))
      end do

      IF(ICRYG.EQ.0)  then
      FmtFormat='(3(F8.4,f8.2),f9.6,f8.2,i4)'
      IF(IXUNIT.EQ.1) then
       FmtFormat='(4(F10.3,f8.2),i4)'
       glb(26)=toftet
      endif
      if(icomm.eq.1) then
       write(i5,'(a)')'!'
       IF(IXUNIT.EQ.1) then
       write(i5,'(a,a)')'!    Zero    Code      Dtt1    Code',
     +  '      Dtt2    Code    2Theta    Code MORE'
       else
       write(i5,'(a,a)')'!  Zero    Code    Sycos    Code   Sysin',
     +  '    Code  Lambda     Code MORE'
       endif
      endif
      WRITE(I5,FmtFormat)GLB(1),AGLB(1),(GLB(J),AGLB(J),J=8,9)
     +,GLB(26),AGLB(26),IGLMORE
       if(IGLMORE.NE.0) THEN
      if(icomm.eq.1) then
       write(i5,'(a)')'!'
       write(i5,'(a)')'! Microabsorption coefficients  '
       write(i5,'(a)')'!   P0    Cod_P0    Cp   Cod_Cp     Tau  Cod_Tau'
      endif
         WRITE(I5,'(3(F8.4,f8.2))') (GLB(J),AGLB(J),J=27,29)
       ENDIF !IGLMORE
      if(NBCKGD.EQ.2.AND.ISBAC.EQ.-1) then
       write(I5,'(f10.2,a)') Fwindow,'    Window for Fourier filtering'
      endif
      IF(NBAC.EQ.0.OR.NBAC.EQ.-1) then
      if(icomm.eq.1) write(i5,'(a)')'!   Background coefficients/codes'
        WRITE(I5,46)(GLB(J),J=2,7),(AGLB(J),J=2,7)
      endif
      IF(NBAC.EQ.1) then
      if(icomm.eq.1)
     + write(i5,'(a)')'!   Background Tranf_coefficients/codes'
       WRITE(I5,'(4F14.5/4F14.5)')(GLB(J),J=22,25),(AGLB(J),J=22,25)
      endif
      IF(NBAC.EQ.-1)  THEN
      if(icomm.eq.1)
     + write(i5,'(a)')'!  Additional background coefficients/codes'
            WRITE(I5,46)(GLB(J),J=10,15),(AGLB(J),J=10,15)
            WRITE(I5,46)(GLB(J),J=16,21),(AGLB(J),J=16,21)
      ENDIF
      ENDIF     !IF(ICRYG.EQ.0)
   46 FORMAT(6G12.5,/,6F12.3)
c---------------------------------------Loop over phases
 477  DO 81 K=1,NPHASE
      if(icomm.eq.1) then
      write(i5,'(a)')'!'
      write(i5,'(a,i3,a,f8.2)')'!  Data for PHASE number: ',K,
     + '  ==> Current R_Bragg: ',R_braggs(k)
      endif
      IF(iabs(JBT(K)).EQ.2.AND.IRF(K).NE.2) IRF(K)=2
      nomag=iabs(JBT(K)).NE.1.AND.iabs(JBT(K)).NE.5
     +     .and.iabs(JBT(K)).NE.10
      IOF=0
      IF(K.GT.1) THEN
       DO IIPHAS=2,K
        IOF = IOF + NATOM (IIPHAS-1)
       end do
      END IF
      WRITE(I5,'(a)')PHSNM(K)
      if(icomm.eq.1) write(i5,'(a)')'!'
C*IF
      NVKK=NVK(K)
      IF(GENK(K).EQ.'Y') NVKK=-NVKK/2
      if(icomm.eq.1) write(i5,'(a,a)')'!Nat Dis Mom Pr1 Pr2 Pr3 Jbt',
     + ' Irf Isy Str Furth     ATZ   Nvk Npr More'
      WRITE(I5,'(3I4,3F4.1,5I4,F12.2,3I4)')NATOM(K),NDIC(K),NMAGC(K),
     &(PREF(K,I),I=1,3),JBT(K),IRF(K),ISYM(K),ISTR(K),IFURT(K),ATZ(K),
     & NVKK,NPRO(K)-1,IMORE(K)
      if(icomm.eq.1) write(i5,'(a)')'!'
      IF(IMORE(K).NE.0) THEN
      if(icomm.eq.1) write(i5,'(a,a)')'!Jvi Jdi Hel Sol Mom Ter  Brind',
     + '   RMua    RMub    RMuc   Jtyp'
       WRITE(I5,'(6I4,4f8.4,i4)') JVIEW(K),JDIST(K),JHELIX(K),JSOL(K),
     +   JMOM(K),JTER(K),BRINL(K),RMUA(K),RMUB(K),RMUC(K),JTYP(k)
      if(icomm.eq.1) write(i5,'(a)')'!'
      ENDIF
      if(mag_grp(k).eq.0) then
       WRITE(I5,'(20A1,"     <--Space group symbol")')(SYMB(K,I),I=1,20)
      else
       WRITE(I5,'(20a1,a)')(SYMB(K,I),I=1,20),' Magnetic symmetry below'
      endif
C
C  WRITE SYMMETRY OPERATORS IF ISYM(K)=1
C---------
      IF(ISYM(K).ne.0) THEN
c---------
      if(icomm.eq.1)write(i5,'(a)')'!Nsym Cen Laue MagMat'
        WRITE(I5,'(4I4)') MLTG(K),ICET(K),NUMSPG(K),NMAGR(K)

      If(ISYM(K).Lt.0) then
        do L=1,NLines_text(k)
         write(i5,'(a)')Page_Text(k,L)
        end do
         write(i5,'(a)')'!'
       ELSE      !Now ISYM >0

      if(icomm .eq. 1 .and. MLTG(K) .ne. 0)then
      write(i5,'(a,a)')'!S11 S12 S13     T1        S21 S22 S23     T2',
     + '    S31 S32 S33       T3'
      if(NMAGR(K).ne.0)
     +write(i5,'(a)')'!M11 M12 M13  M21 M22 M23  M31 M32 M33     Ph'
      endif
      MULTG=MLTG(K)

      DO IR=1,MULTG
        II=IABS(IVEC(K,IR))
        ISS=IVEC(K,IR)/II
        DO J=1,3
         TS(J)=TR(K,IR,J)
         DO L=1,3
          IM(J,L)=ISS*MOD6(II,J,L)
         end do
        end do
      WRITE(I5,'(3(3I4,F12.6))')((IM(J,L),L=1,3),TS(J),J=1,3)
      IF(.not.nomag) then
       DO L=1,NMAGR(K)
        II=IABS(MVEC(K,L,IR))
        ISS=MVEC(K,L,IR)/II
         DO  J=1,3
          DO  JJ=1,3
           IM(J,JJ)=ISS*MOD6(II,J,JJ)
          END DO
         END DO
         WRITE(I5,'(9I4,F12.6)')((IM(J,JJ),JJ=1,3),J=1,3),PMAG(K,L,IR)
         END DO
       ENDIF
       END DO

       ENDIF ! ISYM <0
C---------
      ELSEif(iabs(JBT(K)).eq.10.and.Mag_GRP(k).eq.1) then   !(ISYM(K).eq.0)
c---------
      if(icomm.eq.1)write(i5,'(a)')
     +         '! Time Reversal Operations on Crystal Space Group'
      i_plus=1
      if(icet(K).eq.1) i_plus=0
       WRITE(I5,'(24i3)')  (inv_temp(k,i),i=1,MLTG(K)+i_plus)
      ENDIF

C
      N=NATOM(K)
      IF(NATOM(K).EQ.0) GOTO 172
c------------
      IF(JBT(K).EQ.0) THEN
c------------
      if(icomm.eq.1) then
      write(i5,'(a,a)')'!Atom Typ       X        Y        Z     Biso',
     + '      Occ     In Fin N_t  /Codes'
      if(ianis(k).ne.0)
     + write(i5,'(a,a)')'!    beta11   beta22   beta33   beta12',
     +'   beta13   beta23  /Codes'
      endif
      FmtFormat='(A4,1x,a4,2X,5F9.5,3I4/11X,5F9.2)'
      do I=1,N
      WRITE(I5,FmtFormat) ATEXT(I+IOF),NTYP(I+IOF),
     + (XL(I+IOF,J),J=1, 5),(ISAP(I+IOF,J),J=1,2), n_t(i+iof),
     + (A(I+IOF,J),J=1, 5)
      if(iabs(N_t(i+iof)).eq.2) WRITE(I5,'(2x,6F9.5/2x,6F9.2)')
     +    (XL(I+IOF,J),J=13,18), (A(I+IOF,J),J=13,18)
      if(iabs(N_t(i+iof)).eq.4) then
      if(icomm.eq.1)write(i5,'(a)')'! Form-factor refinable parameters'
        WRITE(I5,'(2x,7F9.5/2x,7F9.2)')
     +    (XL(I+IOF,J),J=19,25), (A(I+IOF,J),J=19,25)
        WRITE(I5,'(2x,7F9.5/2x,7F9.2)')
     +    (XL(I+IOF,J),J=26,32), (A(I+IOF,J),J=26,32)
        endif
      end do

         ELSEif(iabs(JBT(K)).eq.4) then

       FmtFormat='(A4,1x,a4,2X,5F9.5,3F8.3/11X,5F9.2,3f8.2/2x,8F9.5/
     + 2x,7F9.2)'
      if(icomm.eq.1) then
      write(i5,'(a,a)')'!Atom Typ      p1       p2       p3      p4 ',
     + '     p5      p6     p7     p8'
      write(i5,'(a,a)')'!     p9        p10     p11      p12  ',
     +'     p13      p14      p15     p16'
      endif
      write(i5,FmtFormat)(ATEXT(I+IOF),NTYP(I+IOF),
     +(XL(I+IOF,J),J=1,8), (A(I+IOF,J),J=1,8),
     +(XL(I+IOF,J),J=9,16),(A(I+IOF,J),J=9,15),I=1,N)
c
c  Xtal+Magnetic struture
c
      ELSEif(iabs(JBT(K)).eq.10) then

      if(icomm.eq.1) then
      write(i5,'(a,a/a)')'!Atom Typ    Mag Vek      X         Y    ',
     + '     Z       Biso      Occ    N_type','!Line below:Codes'
       if(JBT(K).lt.0) then
      write(i5,'(a,a/a)')'!     Rm      Rphi   Rtheta        Im   ',
     +'    Rphi     Rtheta      MagPh','!Line below:Codes or...'
         else
      write(i5,'(a,a/a)')'!     Rx       Ry        Rz        Ix   ',
     +'     Iy        Iz      MagPh','!Line below:Codes or...'
       endif
      write(i5,'(a,a)')'!    beta11   beta22   beta33   beta12',
     +'   beta13   beta23  /Line below:Codes'
      endif

          DO I=1,N
          WRITE(i5,'(A4,1X,A4,3x,I4,1X,I2,1X,5F10.5,i5)')
     +       ATEXT(I+IOF), NTYP(I+IOF),IMAGR(I+IOF),IKV(I+IOF),
     +      (XL(I+IOF,J),J=1,5),N_T(I+IOF)
            WRITE(i5,'(20X,5F10.2)')(A(I+IOF,J),J=1,5)
C
          IF(N_T(I+IOF).NE.0) THEN
            IF(N_T(I+IOF).EQ.1.OR.N_T(I+IOF).EQ.3) THEN
          WRITE(i5,'(7F10.5,a)')(XL(I+IOF,J),J=6,12),' <-MagPar'
          WRITE(i5,'(7F10.2)')(A(I+IOF,J),J=6,12)
            ENDIF    ! 1-3
            IF(N_T(I+IOF).EQ.2.OR.N_T(I+IOF).EQ.3) THEN
          WRITE(i5,'(6F10.5,a)')(XL(I+IOF,J),J=13,18),' <-Betas'
          WRITE(i5,'(6F10.2)')(A(I+IOF,J),J=13,18)
            ENDIF         ! 2-3
          ENDIF                    !end N_T ><0
          END DO      ! I=1,N
C
C  MAGNETIC STRUCTURE
C
         ELSE
      FmtFormat=
     + '(A4,1x,a4,I3,1X,I2,1X,5F8.5,3F8.3/16X,8F8.2/6F8.3,f8.5/7F8.2)'
      if(icomm.eq.1) then
      if(JBT(K).eq.1) then
      write(i5,'(a,a)')'!Atom Typ  Mag Vek    X      Y      Z    ',
     + '   Biso   Occ      Rx      Ry      Rz'
      write(i5,'(a,a)')'!     Ix     Iy     Iz    beta11  beta22  ',
     + 'beta33   MagPh'
      elseif(JBT(K).eq.-1) then
      write(i5,'(a,a)')'!Atom Typ  Mag Vek    X      Y      Z    ',
     + '   Biso   Occ      Rm      Rphi  Rtheta'
      write(i5,'(a,a)')'!     Im   Iphi   Itheta  beta11  beta22  ',
     + 'beta33   MagPh'
       else
      write(i5,'(a,a)')'!Atom Typ  Mag Vek    X      Y      Z    ',
     + '   Biso   Occ      Mom     beta   Phase'
      write(i5,'(a,a)')'!   Phi & Theta  of Cone-axis + unused params'
       endif
      endif
      WRITE(I5,FmtFormat)(ATEXT(I+IOF),NTYP(I+IOF),IMAGR(I+IOF),
     + IKV(I+IOF), (XL(I+IOF,J),J=1,8), (A(I+IOF,J),J=1,8),
     + (XL(I+IOF,J),J=9,11), (XL(I+IOF,J),J=13,15),XL(I+IOF,12),
     + (A(I+IOF,J),J=9,11), (A(I+IOF,J),J=13,15),A(I+IOF,12),I=1,N)
      ENDIF
C
C                PROFILE PARAMETERS
C
  172 IF(ISTR(K).EQ.0) THEN
        ST1=PAR(K,18)
        ST2=PAR(K,19)
        ST3=PAR(K,20)
        SI1=PAR(K,28)
        SI2=PAR(K,29)
        AST1=APAR(K,18)
        AST2=APAR(K,19)
        AST3=APAR(K,20)
        AS1=APAR(K,28)
        AS2=APAR(K,29)
      ELSE
        ST1=0.0
        ST2=0.0
        ST3=0.0
        AST1=0.0
        AST2=0.0
        AST3=0.0
        AS1=0.0
        AS2=0.0
       ENDIF
        if(iabs(IRF(K)).ne.4) then

        if(ixunit.eq.1) then

         write(i5,'(a,a)')'!  Scale       TOF-Sh1     Bov      S2 ',
     +    '      S1       S0     Strain-Model'
      WRITE(I5,'(G12.5,5F9.4,I8/f12.5,5F9.2)') PAR(K,1),PAR(K,17),
     + PAR(K,2),ST1,ST2,ST3,ISMO(K),
     + APAR(K,1),APAR(K,17),APAR(K,2),AST1,AST2,AST3
         write(i5,'(a,a)')'!      U2       U1        U0         Xt  ',
     +    '      Yt        Z1     Z0     Size-Model'
         WRITE(I5,'(7F10.5,I4/7F10.2)')
     + PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),SI1,SI2,ISI(K),
     + APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),AS1,AS2

        else   !ixunit

        if(icomm.eq.1) then
         write(i5,'(a,a)')'!  Scale       Shape1      Bov     Str1',
     +    '     Str2     Str3    Strain-Model'
         WRITE(I5,'(G12.5,5F9.4,I8/f12.5,5F9.2)') PAR(K,1),PAR(K,17)
     +  ,PAR(K,2),ST1,ST2,ST3,ISMO(K),APAR(K,1),APAR(K,17),APAR(K,2)
     +  ,AST1,AST2,AST3
        if(npro(k).eq.12) then
         write(i5,'(a,a)')'!      Ul       Vl        Wl         Xl  ',
     +    '      Y       GauSiz   LorSiz Size-Model'
        else
         write(i5,'(a,a)')'!      U        V         W          X   ',
     +    '      Y       GauSiz   LorSiz Size-Model'
        endif
         WRITE(I5,'(7F10.5,I4/7F10.2)')
     + PAR(K,3),PAR(K,4),PAR(K,5),PAR(K,15),PAR(K,16),SI1,SI2,ISI(K),
     + APAR(K,3),APAR(K,4),APAR(K,5),APAR(K,15),APAR(K,16),AS1,AS2
        else
      WRITE(I5,50) PAR(K,1),PAR(K,17),PAR(K,2),ST1,ST2,ST3,ISMO(K),
     + APAR(K,1),APAR(K,17),APAR(K,2),AST1,AST2,AST3,
     + PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),SI1,SI2,ISI(K),
     + APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),AS1,AS2
        endif

        if(npro(k).eq.12) then
         write(i5,'(a,a)')'!      Ur       Vr        Wr       Etar',
     +    '0       Xr   '
         WRITE(I5,'(5f10.5/5f10.2)')
     +      PAR(K,46), PAR(K,47), PAR(K,48), PAR(K,49), PAR(K,50),
     +     APAR(K,46),APAR(K,47),APAR(K,48),APAR(K,49),APAR(K,50)
        endif

       endif    !ixunit

       else     !Now iabs(IRF)=4

       write(i5,'(a)')'!  Scale Factors '
       write(i5,'(a)')
     + '!  Sc1       Sc2        Sc3        Sc4        Sc5        Sc6'
      WRITE(I5,'(6g11.4/6f10.2)')
     + (PAR(K,L),L=1,5),PAR(K,12),(APAR(K,L),L=1,5),APAR(K,12)
       write(i5,'(a)')'!  Extinction Parameters '
       write(i5,'(a,a)')'!    Ext1      Ext2      Ext3      Ext4',
     +  '      Ext5      Ext6      Ext7'
      WRITE(I5,'(7F10.4/7F10.2)')(PAR(K,L),L=13,19),(APAR(K,L),L=13,19)
      endif

   50 FORMAT(G12.5,5F8.4,I4,'   Scale ETA Bov Strain'/f12.5,5F8.2/
     + 3F8.5,4f8.4,I4,2X,'U V W X Y Siz12',/,7F8.2)
c  52 FORMAT(G12.5,5F8.4,I4,'   Scale TF1 Bov Strain'/f12.5,5F8.2/
c    + 7F9.3,I3,2X,'T.O.F. shps & Siz12',/,7F9.2)
c
      if(iabs(Irf(k)).eq.4) then
         write(i5,'(a,a)')'!     a          b         c        alpha',
     +    '      beta       gamma'
       write(i5,'(6F11.6/6F11.5)') (PAR(K,I),I=6,11),(APAR(K,I),I=6,11)
         write(i5,'(a)')'!  Not yet used parameters'
         write(i5,'(5F8.5/5F8.2)')
     +   (PAR(K,L1),L1=35,39),(APAR(K,L2),L2=35,39)

      else

      if(ixunit.eq.1) then

         write(i5,'(a,a)')'!     a          b         c        alpha',
     +    '      beta       gamma'
       write(i5,'(6F11.6/6F11.5)') (PAR(K,I),I=6,11),(APAR(K,I),I=6,11)
         write(i5,'(a,a)')'!  Pref1  Pref2    a0      b0      a1 ',
     +    '      b1 '
       write(i5,'(6F8.5/6F8.2)')
     + PAR(K,12),PAR(K,13),PAR(K,14),(PAR(K,L1),L1=35,37),
     + APAR(K,12),APAR(K,13),APAR(K,14),(APAR(K,L2),L2=35,37)

      else
      if(icomm.eq.1) then
         write(i5,'(a,a)')'!     a          b         c        alpha',
     +    '      beta       gamma'
       write(i5,'(6F11.6/6F11.5)') (PAR(K,I),I=6,11),(APAR(K,I),I=6,11)
         write(i5,'(a,a)')'!  Pref1  Pref2   Asy1    Asy2    Asy3',
     +    '     Asy4'
       write(i5,'(6F8.5/6F8.2)')
     + PAR(K,12),PAR(K,13),PAR(K,14),(PAR(K,L1),L1=35,37),
     + APAR(K,12),APAR(K,13),APAR(K,14),(APAR(K,L2),L2=35,37)
      else
      FmtFormat='(6F11.6,1X,''Cell params''/6F11.5/6F8.5,4X,'//
     +' ''O1 O2 A-symtry Params''/6F8.2)'
      write(i5,FmtFormat) (PAR(K,I),I=6,11), (APAR(K,I),I=6,11),
     + PAR(K,12),PAR(K,13),PAR(K,14),(PAR(K,L1),L1=35,37),
     + APAR(K,12),APAR(K,13),APAR(K,14),(APAR(K,L2),L2=35,37)
      endif
      endif

      endif
        if(iuvw.eq.1) then
         WRITE(i5,'(a)')  '!Additional U,V,W parameters for Lambda2'
         WRITE(i5,'(3f10.5,a/3f10.5)')
     +   (PAR(K,L1),L1=43,45),'   <--  U2,V2,W2 for lambda(2) ',
     +   (APAR(K,L1),L1=43,45)
        endif

         if(NPRO(K).EQ.5.OR.NPRO(K).GT.8) then
         WRITE(i5,'(a)')  '!Additional Shape parameters'
      FmtFormat=
     +'(2(F10.5,F8.2),''            Shape: Shp1 cShp1 & Shp2 cShp2'')'
        write(i5,FmtFormat) (PAR(K,L),APAR(K,L),L=41,42)
         endif !NPRO

       if(JSOL(K).ne.0) then
      if(icomm.eq.1) then
         write(i5,'(a)')'!     AsyP    Shift1    Shift2  ModA ModS'
         FmtFormat='(3F10.5,2i5/3F10.2)'
       else
         FmtFormat='(3F10.5,2i5,20X,''Asym, Shifts''/3F10.2)'
       endif
      write(i5,FmtFormat) (PAR(K,I),I=38,40),IASV(K),ISHIF(K),
     +                    (APAR(K,I),I=38,40)
      IF(iabs(Ishif(K)).EQ.1) WRITE(I5,'(3F8.4,12X,A)')(PSH(K,I),I=1,3),
     *              ' Shift-cos(1) or Shift-sin(-1) axis'
       endif
c
      IF(iabs(ISI(K)).EQ.1) WRITE(I5,'(3F8.4,12X,A)') (PSZ(K,I),I=1,3),
     *              ' Platelet-Needle vector (Size)'
      IF(ISMO(K).EQ.7) WRITE(I5,'(3F8.4,12X,A)') (PST(K,I),I=1,3),
     *              ' Axial vector for microstrains'
      IF(ISMO(K).GT.8) then
      if(icomm.eq.1) write(i5,'(a)')
     +   '! 5 additional strain parameters (Istrainmodel>8)'
       WRITE(I5,'(5F14.5/5F14.5)') (Par(K,I),I=21,25),
     * (APar(K,L),L=21,25)
      endif
C*I
      IF(NVK(K).NE.0) THEN
      if(icomm.eq.1) write(i5,'(a)')'! Propagation vectors: '
      DO 373 I=1,IABS(NVKK)
      DO 374 J=1,3
      AVK(K,I,J)=SIGN(1.,AVK(K,I,J))*(FLOAT(10*LVK(K,I,J))+
     *                                      ABS(AVK(K,I,J)))
374   continue
      WRITE(I5,800)(PVK(K,I,J),J=1,3),I
      WRITE(I5,801)(AVK(K,I,J),J=1,3)
373   continue
      END IF
 800  FORMAT(3F12.7,10X,'Propagation Vector ',I2)
 801  FORMAT(3F12.6)
C*F
C
C  WRITING OF FURTHER PARAMETERS IN CASES ISTR><0 OR IFURT><0
C
      IF(IFURT(K).EQ.0) GOTO 613
      if(icomm.eq.1) write(i5,'(a)')'! Further parameters: '
      DO 375 I=1,IFURT(K)
      WRITE(I5,'(A4,F14.6,F14.6)') NAMEF(K,I),PAR(K,I+LASTMPAR),
     +                             APAR(K,I+LASTMPAR)
  375 continue
  613 IF(ISTR(K).EQ.0.OR.ISTR(K).EQ.2) GOTO 715
      if(icomm.eq.1) write(i5,'(a)')'! Additional strain parameters:'
      WRITE(I5,717) (PAR(K,J),J=18,22),(APAR(K,J),J=18,22)
      WRITE(I5,717) (PAR(K,J),J=23,27),(APAR(K,J),J=23,27)
  717 FORMAT(5G14.5/5F14.5)
  777 FORMAT(6G12.4/6F12.4)
  715 IF(ISTR(K).GE.2)then
      if(icomm.eq.1) write(i5,'(a)')'! Generalized strain parameters:'
       WRITE(I5,777)(PAR(K,J),J=29,34),(APAR(K,J),J=29,34)
      endif
c
C-----write CONSTRAINTS
C
      IF(NDIC(K).NE.0) THEN
      if(icomm.eq.1) write(i5,'(a)')'! Soft distance constraints:'
       DO I=1,NDIC(K)
        WRITE(I5,'(2(A4,1X),I3,5(1X,F10.5))') (CATOD(j,K,I),j=1,2),
     +  Isymc(K,I),(transl(j,K,I),j=1,3), DIO(K,I),SDIO(K,I)
       END DO
      ENDIF
      IF(NMAGC(K).NE.0) THEN
      if(icomm.eq.1) write(i5,'(a)')'! Soft moment constraints:'
        DO I=1,NMAGC(K)
         WRITE(I5,'(A2,F8.3,F8.5)') CMATOM(K,I),SMO(K,I),SSMO(K,I)
        END DO
      ENDIF
       IF(iabs(JDIST(K)).EQ.1.AND..not.nomag) CALL ATOMCOR(K,IOF)
       IF(iabs(JDIST(K)).EQ.2) CALL ATOMCOR(K,IOF)
   81 CONTINUE
C
C  Writing NRELL limits of parameters (numpar, lim1, lim2)
C
      if(NRELL.ne.0) then
      if(icomm.eq.1)
     +   write(i5,'(a)')'! Hard limits for selected parameters:'
        do i=1,NRELL
          write(i5,'(i4,2f12.4)') ILI(I),VLIM1(ILI(I)),VLIM2(ILI(I))
        end do
      endif
      if(icryg.eq.2) then
      if(icomm.eq.1)write(i5,'(a)')'! Nconfg   Nsolu  Num_Ref  Nscalef'
          write(i5,'(4i8)') Nconfg,nsolu,nselr,nscalef
      endif
C
      IF(IPL.NE.0)  then
         write(i5,'(a)') '! Iscale    Idif '
         WRITE(I5,'(2I8)')ISCALE,IDIF
      endif
      IF(JCIL.EQ.2) then
         write(i5,'(a)') '!  2Th1    2Th2  '
         WRITE(I5,'(2F8.2)')T1,T2
      endif
c     close(unit=i5)
      RETURN
      END
