C     Last change:  JRC   9 Mar 97   12:23 pm
C*****************************************************************
C  OUTPTR: CALLED BY ITER AT EACH CYCLE
C*****************************************************************
      SUBROUTINE OUTPTR(ICYCLE,ICONDI)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/F1/SMM(MSZ,MSZ),V(MSZ)
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      Common/Rfactor/freed,freed1,chi2,cchi2
      DIMENSION SY(MPAR),SZ(MPAR),BETA4(6),SBETA4(6)
      DIMENSION JPOUT(MSZ),SHF(MSZ),CELL(3),CELANG(3)
      common/anakm/iana(msz)
      LOGICAL YES,NOMAG,RIETV,cye
      CHARACTER TAF*4,line*80
      TAF='L.S.'
      NPOUT=0
      if(nrell.ne.0) then
        do i=1,maxs
         iana(i)=0
        end do
      endif
      IF(IWGT.GT.0) TAF='M.L.'
      YES = (ICYCLE.EQ.MCYCLE).OR.(ICONDI.EQ.123)
      CYE=.TRUE.
      IF(ISHOR.NE.0) CYE=.FALSE.
      IF(YES) CYE=.TRUE.
      IF(CYE)  WRITE(i_out,1)ICYCLE
      IF (ICONDI.EQ.123) then
          call mess(' ')
        call mess(' Convergence reached at this CYCLE !!!!')
        WRITE(i_out,2)
      endif
    2 FORMAT(' =>  Convergence reached at this CYCLE !!!!'/
     *       ' =>  Parameter shifts set to zero')
    1 FORMAT(1H1,120(1H+)//' => CYCLE No.: ',I4)
      IF(YES) WRITE(i_sum,'(/A/)')' ==> RESULTS OF REFINEMENT:'
      IF (YES)  WRITE(i_sum,1001) MAXS
 1001 FORMAT(/' => No. of fitted parameters: ',I4/)
C
C   Calculation of Reliability factors
C
      If(ICRYG.eq.0) then
        call calc_rfac(icycle)
      EndIf              !(ICRYG.eq.0) then
C
      DO 10 IP=1,NPHASE
      IOF=0
      ISPHER=0
      NOMAG=.TRUE.
      RIETV=.FALSE.
      IF(iabs(JBT(IP)).EQ.1.OR.iabs(JBT(IP)).EQ.5) NOMAG=.FALSE.
      IF(iabs(JBT(IP)).EQ.10.and.nmagr(IP).ne.0) NOMAG=.FALSE.
      if(JBT(IP).lt.0.and..not.nomag) ISPHER=1
      IF(IABS(JBT(IP)).LT.2.OR.IABS(JBT(IP)).GT.3) RIETV=.TRUE.
      IF(IP.GT.1) THEN
       DO IIPHAS=2,IP
        IOF = IOF + NATOM(IIPHAS-1)
       end do
      END IF
      IF(CYE) WRITE(i_out,3)IP,PHSNM(IP)
    3 FORMAT(1X,87('-')/' => Phase ',I2,' Name: ',A70/1X,87('-'))
      IF(RIETV.AND.CYE) then
        if(iabs(JBT(IP)).ne.4) then
      WRITE(i_out,4341)
4341  FORMAT(' => New parameters, shifts, and ',
     *'standard deviations'//' Atom',6x,'x',7X,'dx',6X,'sx',7X,'y',7X,
     *'dy',6X,'sy',7X,'z',7X,'dz',6X,'sz',7X,'B',7X,'dB',6X,'sB',
     *6X,'occ.',4X,'docc.',3X,'socc.'/)
        else
      WRITE(i_out,4342)
4342  FORMAT(' => New parameters, shifts, and ',
     *'standard deviations'//' Atom',6X,'P1',5X,'dP1',5X,'sP1',
     *7X,'P2',5X,'dP2',5X,'sP2',7X,'P3',5X,'dP3',5X,'sP3',
     *7X,'P4',5X,'dP4',5X,'sP4',7X,'P5',5X,'dP5',5X,'sP5'/
     *11x,'P6',5x,'dP6',5x,'sP6',7x,'P7',5x,'dP7',5x,'sP7',
     *7x,'P8',5x,'dP8',5x,'sP8'/)
        endif
      endif
      N=NATOM(IP)
      IF (YES) THEN
        WRITE(i_sum,'(/78a1/A,I2,1X,A40,20A1/78a1/)') ('-',i=1,78),
     * ' => Phase No. ',IP,PHSNM(IP),(SYMB(IP,I),I=1,20),('-',i=1,78)
        nrr=IC(IP)
        if(iabs(irf(IP)).eq.4) nrr=NOBSERV(ip)
        WRITE(i_sum,'(A,I6/)')' =>  No. of reflections: ',nrr
        IF (JCIL.GT.0) then
          WRITE(i_rpa,'(a,i1,1x,a40)')'PHAS',IP,PHSNM(IP)
          WRITE(i_rpa,'(a,20A1)')'SPGR ',(SYMB(IP,I),I=1,20)
          WRITE(i_rpa,'(a,I4)')'NATM ',Natom(ip)
          WRITE(i_rpa,'(a,4I4)')'COND ',JBT(IP),IANIS(IP),ISTR(IP),
     +      IFURT(IP)
        ENDIF
      ENDIF
      IF (YES.AND.RIETV) then
        if(iabs(JBT(IP)).ne.4) then
          WRITE(i_sum,1015)
        else
          WRITE(i_sum,1010)
        endif
      endif
c
c  Formats
c
 1010 FORMAT(/' ==> ATOM PARAMETERS defined by user:'//1X,
     &' Name   P1    sP1      P2    sP2      P3     sP3     P4  sP4  '
     &,' P5   sP5'/'         P6    sP6      P7    sP7      P8     sP8'/)
 1015 FORMAT(/' ==> ATOM PARAMETERS:'//1X,
     &' Name    x     sx       y     sy       z      sz      B   sB  '
     &, 'occ.  socc.'/)
c
      jen=5
      if(nomag.and.(iabs(jbt(ip)).ne.10)) jen=8
      DO I=1,N
       DO J=1,jen
        KM=LP(I+IOF,J)
        IF(KM.eq.0) then
         SY(J)=0.
         SZ(J)=0.
        else
         SZ(J)=SQRT(ABS(SMM(KM,KM)))
         SY(J)=V(KM)*A(I+IOF,J)*RELAX(1)
         if(NRELL.eq.0.or.km.gt.MAXS) then
          XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
         else
          call limite(XL(I+IOF,J),SY(J),A(I+IOF,J),KM,npout,Jpout,SHF)
         endif
         if(sz(j).ge.1.0) sz(j)=0.999999
        endif
       END DO
      IF (YES.AND.RIETV.AND.JCIL.GT.0) then
        WRITE(i_rpa,'(a,a4,5f10.5,2i3)')'ATOM ', ATEXT(I+IOF),
     +                (XL(I+IOF,J),J=1,5),(ISAP(I+IOF,J),J=1,2)
        WRITE(i_rpa,'(a,5f10.5)')'SIGM     ',(SZ(J),J=1,5)
      endif
      IF(CYE) WRITE(i_out,100)
     +        ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=1,5)
      IF(CYE.and.iabs(JBT(IP)).eq.4)
     * WRITE(i_out,'(1X,6X,3(3F8.5,1X))')(XL(I+IOF,J),SY(J),SZ(J),J=6,8)
       IF (YES.AND.RIETV) THEN
        WRITE(i_sum,1003)
     +   ATEXT(I+IOF),(XL(I+IOF,J),INT(SZ(J)*100000.),J=1,3),
     +    (XL(I+IOF,J),INT(SZ(J)*1000.),J=4,5)
        IF(iabs(JBT(IP)).eq.4)
     +  WRITE(i_sum,1013)(XL(I+IOF,J),INT(SZ(J)*100000.),J=6,8)
       ENDIF
      END DO
 1003 FORMAT(1X,A4,1X,3(F8.5,'(',I4,')',1X),2(F6.3,'(',I3,')',1X))
 1013 FORMAT(6x,3(F8.5,'(',I4,')',1X) )
  100 FORMAT(1X,A4,2X,5(3F8.5,1X))
C
C  ANISOTROPIC WRITING
C
      IF(RIETV.AND.IANIS(IP).EQ.1)THEN
        if(iabs(JBT(IP)).ne.4) then
         IF(CYE) WRITE(i_out,101)
         IF(YES) WRITE(i_sum,105)
         jin=13
         jfin=18
        else
         jin=9
         jfin=15
         IF(CYE) WRITE(i_out,1011)
         IF(YES) WRITE(i_sum,1012)
        endif
c
  101 FORMAT(/' Atom',7X,3HB11,6X,4HdB11,6X,4HsB11,7X,3HB22,6X,4HdB22,
     }6X,4HsB22,7X,3HB33,6X,4HdB33,6X,4HsB33,/,12X,3HB12,6X,4HdB12,6X,
     }4HsB12,7X,3HB13,6X,4HdB13,6X,4HsB13,7X,3HB23,6X,4HdB23,6X,4HsB23)
 1011 FORMAT(/' Atom',7X,' P9',6X,' dP9',6X,' sp9',
     *7X,'P10',6X,'dP10',6X,'sP10',7X,'P11',6X,'dP11',6X,'sP11'/
     *12X,'P12',6X,'dP12',6X,'sP12',7X,'P13',6X,'dP13',6X,'sP13',
     *7X,'P14',6X,'dP14',6X,'sP14'/12X,'P15',6X,'dP15',6X,'sP15'/)
c
  105 FORMAT(/1X,'=>   Anisotropic Betas*1E04'//1X,
     &'Name      B11     B22     B33     B12     B13     B23  '/1X,
     &'         sB11    sB22    sB33    sB12    sB13    sB23  '/)
 1012 FORMAT(/1X,'=>   User defined Parameters'//
     &' Name     P9       P10       P11       P12       P13       P14
     &   P15'/
     &'         sP9      sP10      sP11      sP12      sP13      sP14
     &  sP15'/)
c
      DO I=1,N
       DO J=jin,jfin
        KM=LP(I+IOF,J)
        IF(KM.EQ.0) THEN
         SY(J)=0.
         SZ(J)=0.
        ELSE
         SZ(J)=SQRT(ABS(SMM(KM,KM)))
         SY(J)=V(KM)*A(I+IOF,J)*RELAX(2)
         if(NRELL.eq.0.or.km.gt.MAXS) then
          XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
         else
          call limite(XL(I+IOF,J),SY(J),A(I+IOF,J),KM,npout,Jpout,SHF)
         endif
        ENDIF
       END DO

        if(iabs(JBT(IP)).ne.4) then
      IF(CYE)WRITE(i_out,102)
     +       ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=jin,jfin)
         IF(YES) THEN
          ibetas=0
           DO  J=jin,18
            BETA4(J-12)=XL(I+IOF,J)*10000.0
            ibetas=ibetas+nint(BETA4(J-12))
            SBETA4(J-12)=SZ(J)*10000.0
           END DO
          WRITE(i_sum,104)
     +         ATEXT(I+IOF),(BETA4(J),J=1,6),(SBETA4(LL),LL=1,6)
          if(ibetas.gt.1) then
            do j=1,3
             cell(j)=save(ip,j)
             celang(j)=save(ip,j+3)
            end do
            call RMS_B(cell,celang,beta4)
          endif
         ENDIF
      else
       IF(CYE)WRITE(i_out,77)
     +    ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=jin,jfin)
       IF(YES)WRITE(i_sum,78)ATEXT(I+IOF),(XL(I+IOF,J),J=jin,jfin),
     +                                (SZ(J),J=jin,jfin)
      endif
      END DO    ! END Loop over atoms

  104 FORMAT(1X,A4,1X,6F8.1/6X,6F8.1)
  102 FORMAT(1X,A4,9F10.6,/,5X,9F10.6)
   77 FORMAT(1X,A4,9F10.6,/5X,9F10.6/5X,9F10.6/5X,9F10.6)
   78 FORMAT(1X,A4,7(1X,F9.5)/5X,7(1X,F9.5))
      ENDIF   !IF(RIETV.AND.IANIS(IP).EQ.1)
C
C   END OF ANISOTROPIC WRITING (or user-supplied parameters 9->15)
C

cccccccccccccccc         if(iforf(IP).eq.1) jfin=32
c  FORM FACTOR REFINEMENT

      IF(RIETV.AND.IANIS(IP).EQ.3)THEN
         jin=19
         jfin=32
       IF(CYE) then
         line='Form-Factor Parameters:'
         WRITE(i_out,'(/1x,a,a/)')'=>', line
         line='Atom      f1,3..     df1,3..     sf1,3..      '//
     +        'f2,4..     df2,4..     sf2,4..'
         WRITE(i_out,'(/1x,a,a/)') line
       endif
       IF(YES) then
         line='Form-Factor Parameters:'
         WRITE(i_sum,'(/1x,a,a/)')'=>', line
         line='Atom        f1        f2        f3'//
     +   '        f4        f5        f6        f7'
         WRITE(i_sum,'(a)') line
         line=        '           sf1       sf2       sf3'//
     +   '       sf4       sf5       sf6       sf7'
         WRITE(i_sum,'(a)') line
         line='            f8        f9       f10'//
     +   '       f11       f12       f13       f14'
         WRITE(i_sum,'(a)') line
         line='           sf8       sf9      sf10'//
     +   '      sf11      sf12      sf13      sf14'
         WRITE(i_sum,'(a)') line
       endif
      DO I=1,N
       DO J=jin,jfin
        KM=LP(I+IOF,J)
        IF(KM.NE.0) then
         SZ(J)=SQRT(ABS(SMM(KM,KM)))
         SY(J)=V(KM)*A(I+IOF,J)*RELAX(2)
         if(NRELL.eq.0.or.km.gt.MAXS) then
          XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
         else
          call limite(XL(I+IOF,J),SY(J),A(I+IOF,J),KM,npout,Jpout,SHF)
         endif
        else
         SY(J)=0.
         SZ(J)=0.
        endif
       END DO

       IF(CYE) WRITE(i_out,177)
     +    ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=jin,jfin)
       IF(YES)WRITE(i_sum,178)ATEXT(I+IOF),(XL(I+IOF,J),J=19,25),
     +  (SZ(J),J=19,25),(XL(I+IOF,J),J=26,32),(SZ(J),J=26,32)
      END DO    ! END Loop over atoms
  177 FORMAT(1X,A4,6F12.6,/6(5X,6F12.6/))
  178 FORMAT(1X,A4,7(1X,F9.5)/3(5X,7(1X,F9.5)/))

      ENDIF   !IF(RIETV.AND.IANIS(IP).EQ.3)


C
C  SUMS OVER CONSTRAINTS
C
      IF(NDIC(IP).NE.0) THEN
       IF(CYE) then
       WRITE(i_out,'(/A/)')
     +' => Distance constraints:      Dobs     Dcalc  diff/sigma'
      do i=1,ndic(ip)
       WRITE(i_out,'(a,a4,a,a4,a,2f10.5,f12.5)')
     +'    (',catod(1,ip,i),' - ',catod(2,ip,i),'):       ',
     +dio(ip,i),dioc(ip,i),(dio(ip,i)-dioc(ip,i))/sdio(ip,i)
      end do
      endif
      X1=CHI2*SUMACD(IP)*NAPCD(IP)
      RATX1=X1/S2
      IF(CYE)WRITE(i_out,'(/A/A,I2,A,G12.3,4X,A,F12.5/A,G12.3/A,G12.3)')
     *' => Slack Constraints(dist):',
     *'         Sum{W(Dobs-Dcal)**2}/',NAPCD(IP),' =',SUMACD(IP),
     *' SM/S2 =',RATX1,
     *'    SM=Chi2*Sum{W(Dobs-Dcal)**2} =',X1,
     *'    S2=     Sum{w(yobs-ycal)**2} =',S2
      IF(CYE) WRITE(i_out,'(A,I2,A,F10.4)')
     *'   Rms=Sqrt{Sum[Dobs-Dcal]**2/',NAPCD(IP),'}=',RMSD(IP)
      IF(YES) THEN
      WRITE(i_sum,'(/A/A,I2,A,G12.3,4X,A,F12.5/A,G12.3/A,G12.3)')
     *' => Slack Constraints(dist):',
     *'         Sum{W(Dobs-Dcal)**2}/',NAPCD(IP),' =',SUMACD(IP),
     *' SM/S2 =',RATX1,
     *'    SM=Chi2*Sum{W(Dobs-Dcal)**2} =',X1,
     *'    S2=     Sum{w(yobs-ycal)**2} =',S2
      WRITE(i_sum,'(A,I2,A,F10.4)')
     *'   Rms=Sqrt{Sum[Dobs-Dcal]**2/',NAPCD(IP),'}=',RMSD(IP)
      ENDIF
      ENDIF

C--------------------------------------------------------------------
C   MAGNETIC WRITING
C--------------------------------------------------------------------
      IF(NOMAG) GOTO 2000
      call Mag_write(n,ip,iof,npout,ispher,cye,yes,jpout,shf)
c-------------------------------------------------------------------------
C   Intensity-independent parameters of each phase
c-------------------------------------------------------------------------
C
 2000 call Profile_param(ip,npout,cye,yes,jpout,shf)
c
c  Output R-factors for integrated intensity phases done in BRAGG
c
c     if(iabs(irf(IP)).eq.4) then
c      iexput=0
c      Call Integ_output(IP,iexput)
c     endif
C
C  END OF FURTHER PARAMETERS
C
   10 CONTINUE            !End loop over phases

      If(ICRYG.eq.0) then
      DO J=1,NGL
       KM=LGLB(J)
       IF(KM.EQ.0) THEN
        SY(J)=0.
        SZ(J)=0.
       ELSE
        SZ(J)=SQRT(ABS(SMM(KM,KM)))
        SY(J)=V(KM)*AGLB(J)*RELAX(4)
        if(NRELL.eq.0.or.km.gt.MAXS) then
         GLB(J)=GLB(J)+SY(J)
        else
         call limite(GLB(J),SY(J),AGLB(J),KM,npout,Jpout,SHF)
        endif
       ENDIF
      END DO
        if(LGLB(26).ne.0.and.GLB(26).gt.0.0) then
         LAMDA(1)=GLB(26)
         LAMDA(2)=GLB(26)
        endif
c
c  Put limits to the variation of the background transforming coefficients
c
      if(lglb(24).ne.0) then
      if(abs(GLB(24)).gt.0.1) then
       GLB(24)=0.0
       sz(24)=0.999900
      endif
      endif
      if(lglb(25).ne.0) then
      if(abs(GLB(25)).gt.3.0) then
       GLB(25)=0.0
       sz(25)=0.999900
      endif
      endif
c
      IF(CYE) then
        WRITE(i_out,109)GLB(1),SY(1),SZ(1)
 109  FORMAT(/' ==> GLOBAL PARAMETERS:'//' => Zero-point: ',3F8.4)
        if(LGLB(26).ne.0) WRITE(i_out,'(a,3f9.6)')
     +' => Refined wavelength: ',GLB(26),SY(26),SZ(26)
      endif
      IF(IGLMORE.NE.0) then
       if(glb(27).gt.1) then
        glb(27)=0.5
      call mess(' Warning! Microabsorption parameter P0 > 1 !')
       write(i_out,'(/a/a)')
     +' ----> Warning! Microabsorption parameter P0 >1 !',
     +'       Program is fixing P0 to 0.5 (s.d. unreliable)'
       endif
c
c Check positivity of microabsorption parameters
c
       negative=1
       if(glb(27).lt.0) then
        glb(27)=0.00001
       else if(glb(28).lt.0) then
        glb(28)=0.00001
       else if(glb(29).lt.0) then
        glb(29)=0.00001
       else
        negative=0
       endif
       if(negative.eq.1) then
      call mess(' Warning! Some microabsorption parameter <0')
      call mess(' Program is fixing such values! ')
       write(i_out,'(/a/a)')
     +' ----> Warning! Some microabsorption parameter is negative!',
     +'    Program is fixing such values to 0.00001 (s.d. unreliables)'
      endif

      WRITE(i_out,'(/a/3(1x,3f12.5/))')
     +' => Microabsorption parameters ==> ',(GLB(J),SY(J),SZ(J),J=27,29)
      endif
      IF (YES) THEN
        WRITE(i_sum,1018)GLB(1),SZ(1)
        if(LGLB(26).ne.0) WRITE(i_sum,'(a,2f9.6)')
     +' => Refined wavelength: ',GLB(26),SZ(26)
      IF(IGLMORE.NE.0) WRITE(i_sum,'(/a/3(29x,2f12.5/))')
     +' => Microabsorption parameters ==> ',(GLB(J),SZ(J),J=27,29)
        IF (JCIL.GT.0) then
          WRITE(i_rpa,'(A,2F10.5)')'ZERO ',GLB(1),SZ(1)
        if(LGLB(26).ne.0)WRITE(i_rpa,'(A,2F10.5)')'LAMB ',GLB(26),SZ(26)
       IF(IGLMORE.NE.0)WRITE(i_rpa,'(A,6F10.5)')'MICR ',
     +                                            (GLB(j),SZ(j),j=27,29)
        endif
      ENDIF

 1018 FORMAT(/' ==> GLOBAL PARAMETERS:'//' => Zero-point: ',2F8.4)
      IF(NBCKGD.EQ.0.OR.( NBCKGD.EQ.1.AND.ISBAC.EQ.-1) ) THEN
      IF(CYE) WRITE(i_out,84)(GLB(J),SY(J),SZ(J),J=2,7)
   84 FORMAT(' => Background Polynomial Parameters ==>'/(1X,3G12.6))
      IF (YES) THEN
        WRITE(i_sum,1019)(GLB(J),SZ(J),J=2,7)
 1019 FORMAT(' => Background Polynomial Parameters ==>'/(29X,2G12.6))
        WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
          WRITE(i_rpa,'(A,6G12.4)')'BACK ',(GLB(J),J=2,7)
          WRITE(i_rpa,'(A,6G12.4)')'SIGM ',(SZ(J),J=2,7)
        ENDIF
      ENDIF
       if(isbac.eq.-1) then

         IF(CYE) WRITE(i_out,53)
     +(GLB(J+9),SY(J+9),SZ(J+9),GLB(J+15),SY(J+15),SZ(J+15),J=1,6)
   53 format(/' => Background Debye-Parameters ==>'//
     +'     Bc       DBc       SBc           d       Dd        Sd'//
     + 3F10.4,2x,3f10.4)

      IF (YES) THEN
      WRITE(i_sum,52) (GLB(J+9),SZ(J+9),GLB(J+15),SZ(J+15),J=1,6)
   52 format(/' => Background Debye-Parameters ==>'//
     +'      Bc        SBc            d       Sd'//
     + 2F10.4,2x,2f10.4)
        WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
          WRITE(i_rpa,'(A,6G12.4)')'BACQ ',(GLB(J),J=10,15)
          WRITE(i_rpa,'(A,6G12.4)')'SIGM ',(SZ(J),J=10,15)
          WRITE(i_rpa,'(A,6G12.4)')'BACD ',(GLB(J),J=16,21)
          WRITE(i_rpa,'(A,6G12.4)')'SIGM ',(SZ(J),J=16,21)
        ENDIF
      ENDIF

       endif
      ENDIF
c
c---------------------New background coefficients---------------
c
       if(NBCKGD.EQ.1.and.isbac.eq.1) then
      IF(CYE) WRITE(i_out,153) (GLB(J),SY(J),SZ(J),J=22,25)
  153 format(/' => Background transforming coefficients ==>'
     +       /(10X,3f16.6) )
      IF (YES) THEN
        WRITE(i_sum,152)  (GLB(J),J=22,25),(SZ(J),J=22,25)
  152 format(/' => Background transforming coefficients  ==>'//
     +'         a/Sa          b/Sb          c/Sc          d/Sd '//
     +4(F14.5)/4(f14.5))
        WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
          WRITE(i_rpa,'(A,6G12.4)')'BACT ',(GLB(J),J=22,25)
          WRITE(i_rpa,'(A,6G12.4)')'SIGM ',(SZ(J),J=22,25)
        ENDIF
      ENDIF
       endif
c---------------------------------------------------------------
   80 CONTINUE
      if(ixunit.eq.1) then
      IF(CYE) WRITE(i_out,183) (GLB(J),SY(J),SZ(J),J=8,9)
183   FORMAT (/' => T.O.F.- dtt1 (    TOFo=dtt1*dsp    ):',3F10.2,/,
     +         ' => T.O.F.- dtt2 (TOF=TOFo+dtt2*dsp*dsp):',3F10.2)
      IF(YES) WRITE(i_sum,1183) (GLB(J),SZ(J),J=8,9)
1183  FORMAT ( ' => T.O.F.- dtt1 (    TOFo=dtt1*dsp    ):',2F10.2,/,
     +         ' => T.O.F.- dtt2 (TOF=TOFo+dtt2*dsp*dsp):',2F10.2)
       dtt1=glb(8)
       dtt2=glb(9)
      else
      IF(CYE) WRITE(i_out,181) (GLB(J),SY(J),SZ(J),J=8,9)
181   FORMAT (/' => Cos( theta)-shift parameter : ',3F8.4,/,
     +         ' => Sin(2theta)-shift parameter : ',3F8.4)
      IF(YES) WRITE(i_sum,1181) (GLB(J),SZ(J),J=8,9)
1181  FORMAT ( ' => Cos( theta)-shift parameter : ',2F8.4,/,
     +         ' => Sin(2theta)-shift parameter : ',2F8.4)
      endif
c
c   Print parameters out of limits
c
      if(cye.and.NRELL.ne.0.and.npout.ne.0)call Plimite(yes,npout,Jpout)
      call Write_R_factors(cye,yes,icycle,taf)
      EndIf              !(ICRYG.eq.0) then
      CALL BRAGG(CYE)
      if(NBCKGD.eq.2.and.ISBAC.eq.-1.and.ICRYG.eq.0) call BAC_FILTER
      RETURN
      END
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      Subroutine Profile_param(ip,npout,cye,yes,jpout,shf)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/F1/SMM(MSZ,MSZ),V(MSZ)
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      Common/Rfactor/freed,freed1,chi2,cchi2
      DIMENSION SKY(24,3),SKZ(24,3),cell(3),celang(3)
      DIMENSION SY(MPAR),SZ(MPAR),DCSM(6,6),DCV(6)
      DIMENSION JPOUT(MSZ),SHF(MSZ),ALI(3,3)
      common/anakm/iana(msz)
      LOGICAL YES,cye
      CHARACTER BRZ*40,fmtform*512

      DO J=1,MPAR
       KM=LPAR(IP,J)
       IF(KM.EQ.0) THEN
        SY(J)=0.
        SZ(J)=0.
       ELSE
        SZ(J)=SQRT(ABS(SMM(KM,KM)))
        SY(J)=V(KM)*APAR(IP,J)*RELAX(3)
        if(NRELL.eq.0.or.km.gt.MAXS) then
         PAR(IP,J)=PAR(IP,J)+SY(J)
         if(NPRO(IP).eq.8.or.NPRO(IP).eq.5) then
          if(par(ip,15).lt.0.) then
           Call mess(' WARNING, parameter X < 0, fixed to 0.0001')
           par(ip,15)=0.0001
           sz(15)=1.000000
          endif
          if(par(ip,16).lt.0.) then
           Call mess(' WARNING, parameter Y < 0, fixed to 0.0001')
           par(ip,16)=0.0001
           sz(16)=1.000000
          endif
         endif
        else
         call limite(PAR(IP,J),SY(J),APAR(IP,J),KM,npout,Jpout,SHF)
        endif
      ENDIF !KM
      END DO   !J=1,MPAR
c
C Next statement prevents scale factor going to negative values
c
      if(iabs(irf(ip)).eq.4) then
       do i=1,5
      if(PAR(IP,i).LT.0.0) then
       PAR(IP,i)=1.0E-15
      Call message(' WARNING, Negative Scale factor number:',I,0.,1)
      Call mess(' Program is fixing SCALE to 1.E-15 ')
      endif
       end do
      if(PAR(IP,12).LT.0.0) then
       PAR(IP,12)=1.0E-15
      Call message(' WARNING, Negative Scale factor number:',I,0.,1)
      Call mess(' Program is fixing SCALE to 1.E-15 ')
      endif
        else
      if(PAR(IP,1).LT.0.0) then
       PAR(IP,1)=1.0E-15
      Call message(' WARNING, Negative Scale factor for phase:',IP,0.,1)
      Call mess(' Program is fixing SCALE to 1.E-15 ')
      endif
c
c  Check preferred orientation parameters
c
      if(Par(ip,13).lt.0.) Par(ip,13)=0.0
      if(Par(ip,13).gt.1.) Par(ip,13)=1.0
      if(nori.eq.1) then
       if(Par(ip,12).lt.0.) Par(ip,12)=1.0
      endif

      endif  !irf(ip).eq.4
C*I
      DO IK=1,NVK(IP)
       DO J=1,3
        KM=LVK(IP,IK,J)
        IF(KM.EQ.0) THEN
         SKY(IK,J)=0.
         SKZ(IK,J)=0.
        ELSE
         SKZ(IK,J)=SQRT(ABS(SMM(KM,KM)))
         SKY(IK,J)=V(KM)*AVK(IP,IK,J)*RELAX(3)
         if(NRELL.eq.0.or.km.gt.MAXS) then
          PVK(IP,IK,J)=PVK(IP,IK,J)+SKY(IK,J)
         else
      call limite(PVK(IP,IK,J),SKY(IK,J),AVK(IP,IK,J),M,npout,Jpout,SHF)
         endif
        ENDIF
       END DO !J
      END DO  !IK
C*F
C     Save cell parameters and direct metrics
C
      CALL DIRECT(DCSM,DCV,IP)
      DO I=1,6
       if(i.gt.3.and.abs(dcv(i)-90.0).lt.0.0001) dcv(i)=90.0
       if(i.gt.3.and.abs(dcv(i)-120.0).lt.0.0001) dcv(i)=120.0
       SY(I+5)=DCV(I)-SAVE(IP,I)
       SAVE(IP,I)=DCV(I)
      END DO
        DO I=1,3
         cell(i)=dcv(i)
         celang(i)=dcv(i+3)
        End Do
        call get_dmetric(cell,celang,ali)
        DO I=1,3
         DO J=1,3
          GD(IP,I,J)=ALI(I,J)
         END DO
        END DO
C
      IF(ISTR(IP).EQ.0) THEN            !ISTR-if

      IF(CYE.and.iabs(irf(Ip)).ne.4) then
c     WRITE(i_out,103) PAR(IP,1),SY(1),SZ(1),
      if(ixunit.eq.1) then
      fmtform='(/'' => Overall scale factor: '',3F14.9/'//
     +''' => T.O.F. Shape parameter h : '',3F10.6/'//
     +''' => Overall Tem. factor: '',3F10.6/'//
     +''' => T.O.F. FWHM parameters u2,u1,u0: '',/,3(5X,3F10.6,/),'//
     +''' => Cell parameters: '',/,6(4x,3F11.6,/),'//
     +''' => Preferred orientation: '',/,2(5X,3F10.6,/),'//
     +''' => T.O.F. shape a0,b0,a1,b1: '',/,4(5X,3F10.6,/),'//
     +''' => XTOF and YTOF parameters: '',/,2(5X,3F10.6,/),'//
     +''' => Strain parameters s2,s1,s0: '',/,3(5X,3F10.6,/),'//
     +''' => Size   parameters Z1,Z0: '',2(/5X,3F10.6) )'
       else
      fmtform='(/'' => Overall scale factor: '',3F14.9/'//
     +''' => ETA(p-Voigt) or M(Pearson VII): '',3F10.6/'//
     +''' => Overall Tem. factor: '',3F10.6/'//
     +''' => Halfwidth parameters: '',/,3(5X,3F10.6,/),'//
     +''' => Cell parameters: '',/,6(4x,3F11.6,/),'//
     +''' => Preferred orientation: '',/,2(5X,3F10.6,/),'//
     +''' => Asymmetry parameters: '',/,4(5X,3F10.6,/),'//
     +''' => X and Y parameters: '',/,2(5X,3F10.6,/),'//
     +''' => Strain parameters: '',/,3(5X,3F10.6,/),'//
     +''' => Size   parameters: '',2(/5X,3F10.6) )'
      endif !ixunit
      WRITE(i_out,fmtform) PAR(IP,1),SY(1),SZ(1),
     +PAR(IP,17),SY(17),SZ(17),
     +(PAR(IP,I),SY(I),SZ(I),I=2,5),
     +(DCV(I),SY(I+5),DCSM(I,I),I=1,6),
     +(PAR(IP,I),SY(I),SZ(I),I=12,14),(PAR(IP,I),SY(I),SZ(I),I=35,37),
     +(PAR(IP,I),SY(I),SZ(I),I=15,16),(PAR(IP,I),SY(I),SZ(I),I=18,20),
     +PAR(IP,28),SY(28),SZ(28),PAR(IP,29),SY(29),SZ(29)
       if(npro(ip).eq.12) then
      fmtform=
     +'('' => Split pV params. (Ur,Vr,Wr,Et0r,Xr): '',5(/5X,3F10.6))'
        WRITE(i_out,fmtform) (PAR(IP,I),SY(I),SZ(I),I=46,50)
       endif
      endif

         ELSE       !ISTR-if

      IF(CYE) WRITE(i_out,1039) PAR(IP,1),SY(1),SZ(1),
     }PAR(IP,17),SY(17),SZ(17),
     }(PAR(IP,I),SY(I),SZ(I),I=2,5),
     *(DCV(I),SY(I+5),DCSM(I,I),I=1,6),(PAR(IP,I),SY(I),SZ(I),I=12,14),
     *(PAR(IP,I),SY(I),SZ(I),I=35,37),(PAR(IP,I),SY(I),SZ(I),I=15,16)
 1039 FORMAT(/' => Overall scale factor: ',3F14.9,/,
     *' => ETA(p-Voigt) or M(Pearson VII): ',3F10.6,/,
     *' => Overall Tem. factor: ',3F10.6,/,
     *' => Halfwidth parameters: ',/,3(5X,3F10.6,/),
     *' => Cell parameters: ',/,6(5x,3F11.6,/),
     *' => Preferred orientation: ',/,2(5X,3F10.6,/),
     *' => Asymmetry parameters: ',/,4(5X,3F10.6,/),
     *' => X and Y parameters: ',/,2(5X,3F10.6,/))
      ENDIF       !ISTR-if

      IF(CYE.and.iabs(irf(Ip)).eq.4)WRITE(i_out,107)
     * (PAR(IP,I),SY(I),SZ(I),I=1,5),(PAR(IP,I),SY(I),SZ(I),I=12,19)
  107 FORMAT(/' => Scale factors: ',/,6(5x,3F11.6,/),/,
     *' => Extinction Parameters: ',/,7(5x,3F11.6,/),/)

      IF(CYE.and.iabs(irf(Ip)).ne.4) then
      if(iuvw.eq.1)
     *WRITE(i_out,110) (PAR(IP,I),SY(I),SZ(I),I=43,45)
  110 FORMAT(' => U,V,W for Lambda(2): ',3(/5X,3F8.5))
      if(NPRO(IP).eq.5.or.NPRO(IP).gt.8)
     *WRITE(i_out,108) PAR(IP,41),SY(41),SZ(41),PAR(IP,42),SY(42),SZ(42)
  108 FORMAT(' => Further shape parameters: ',2(/5X,3F10.6))
      endif

      IF(NVK(IP).NE.0) THEN

      DO 376 IK=1,NVK(IP)
      if(iabs(jbt(ip)).eq.5) then
        BRZ=' '
       else
      if(IBZ(ip,Ik).eq.0) then
       BRZ='K non-equivalent to -K (1/2 * Fourier_C)'
      else
       BRZ='K equivalent to -K '
      endif
      endif
      IF(CYE) WRITE(i_out,106)
     + IK,(PVK(IP,IK,J),SKY(IK,J),SKZ(IK,J),J=1,3),BRZ
  376 continue

  106 FORMAT(' => Propagation Vector',I3,' [K]=',3(3F8.4,1X)/' -> ',a)
      ENDIF     !NVK
C*F

      IF (YES.and.iabs(Irf(IP)).ne.4) THEN
        WRITE(i_sum,1016)
 1016 FORMAT(/' ==> PROFILE PARAMETERS:'//
     *       ' => Cell parameters      :')
        WRITE(i_sum,'((27X,2F10.5))') (DCV(I),DCSM(I,I),I=1,6)
        WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
         WRITE(i_rpa,'(A,6F10.5)')'CELL ', (DCV(I),I=1,6)
         WRITE(i_rpa,'(A,6F10.5)')'SIGM ', (DCSM(I,I),I=1,6)
        ENDIF
C*I
      IF(JCIL.GT.0) WRITE(i_rpa,'(A,I5)')'NNVK ',NVK(IP)
      IF(NVK(IP).NE.0) THEN
      WRITE(i_sum,'(/A/)')' => Propagation vectors [K]:'
      DO 377 IK=1,NVK(IP)
      if(iabs(jbt(ip)).eq.5) then
        BRZ=' '
       else
       if(IBZ(ip,Ik).eq.0) then
        BRZ='K non-equivalent to -K (1/2 * Fourier_C)'
       else
        BRZ=' K equivalent to -K '
       endif
      endif
      WRITE(i_sum,'(I5,3F10.5,'' ->'',A/5X,3F10.5)')
     & IK,(PVK(IP,IK,J),J=1,3),BRZ,(SKZ(IK,J),J=1,3)
      IF(JCIL.GT.0) THEN
       WRITE(i_rpa,'(A,I2,3F10.5/A,3F10.5)')'VECK',IK
     &    ,(PVK(IP,IK,J),J=1,3),'SIGM ',(SKZ(IK,J),J=1,3)
      ENDIF
 377  continue
      WRITE(i_sum,'(A)')' '
      ENDIF
C*F
      ENDIF
      IF (YES.and.iabs(Irf(IP)).ne.4) THEN
      IF(ISTR(IP).EQ.0) THEN

       if(ixunit.eq.1) then
      fmtform='('' => Overall scale factor : '',2F14.9/,'//
     +  ''' => T.O.F. Shape par. h  : '',2F10.5/,'//
     +  ''' => Overall Tem. factor  : '',2F10.5/,'//
     +  ''' => T.O.F. FWHM params.  : '',2F10.5/2(27X,2F10.5,/),'//
     +  ''' => Preferred orientation: '',2F10.5/27X,2F10.5/,'//
     +  ''' => T.O.F.   a0,b0,a1,b1 : '',2F10.5/3(27X,2F10.5,/),'//
     +  ''' => XTOF and YTOF params : '',2F10.5/27X,2F10.5/,'//
     +  ''' => Strain par. s2,s1,s0 : '',2F10.5/2(27X,2F10.5/),'//
     +  ''' => Size parameters Z1,Z0: '',2F10.5/27X,2F10.5)'
        else
      fmtform='('' => Overall scale factor : '',2F14.9/,'//
     +  ''' => ETA(p-V) or M(P-VII) : '',2F10.5/,'//
     +  ''' => Overall Tem. factor  : '',2F10.5/,'//
     +  ''' => Halfwidth parameters : '',2F10.5/2(27X,2F10.5,/),'//
     +  ''' => Preferred orientation: '',2F10.5/27X,2F10.5/,'//
     +  ''' => Asymmetry parameters : '',2F10.5/3(27X,2F10.5,/),'//
     +  ''' => X and Y parameters   : '',2F10.5/27X,2F10.5/,'//
     +  ''' => Strain parameters    : '',2F10.5/2(27X,2F10.5,/),'//
     +  ''' => Size   parameters    : '',2F10.5/27X,2F10.5)'
        endif


        WRITE(i_sum,fmtform) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,14)
     *               ,(PAR(IP,I),SZ(I),I=35,37)
     *               ,(PAR(IP,I),SZ(I),I=15,16)
     *               ,(PAR(IP,I),SZ(I),I=18,20),PAR(IP,28),SZ(28)
     *               ,PAR(IP,29),SZ(29)

       if(npro(ip).eq.12) then
      fmtform='('' => Split pV parameters (Ur,Vr,Wr,EtaR0,Xr): '',
     +  5(/27X,2F10.5) )'
        WRITE(i_sum,fmtform) (PAR(IP,I),SZ(I),I=46,50)
       endif

        IF (JCIL.GT.0) WRITE(i_rpa,5017) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,14)
     *               ,(PAR(IP,I),SZ(I),I=35,37)
     *               ,(PAR(IP,I),SZ(I),I=15,16)
     *               ,(PAR(IP,I),SZ(I),I=18,20),PAR(IP,28),SZ(28)
     *               ,PAR(IP,29),SZ(29)
 5017 FORMAT('SCAL ',2F14.9/,
     *       'SHAP ',2F9.5/,
     *       'BOVE ',2F9.4/,
     *       'HUVW ',6F9.4/,
     *       'PREF ',4F9.4/,
     *       'ASYM ',8F9.4/,
     *       'XYPA ',4F9.4/,
     *       'STRA ',6F9.4/,
     *       'SIZE ',4F9.4)
        ELSE
        WRITE(i_sum,11017) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,14)
     *               ,(PAR(IP,I),SZ(I),I=35,37)
     *               ,(PAR(IP,I),SZ(I),I=15,16)
11017 FORMAT(' => Overall scale factor : ',2F14.9/,
     *       ' => ETA(p-V) or M(P-VII) : ',2F10.5/,
     *       ' => Overall Tem. factor  : ',2F10.5/,
     *       ' => Halfwidth parameters : ',2F10.5/2(27X,2F10.5,/),
     *       ' => Preferred orientation: ',2F10.5/27X,2F10.5/,
     *       ' => Asymmetry parameters : ',2F10.5/3(27X,2F10.5,/),
     *       ' => X and Y parameters   : ',2F10.5/27X,2F10.5/)
        IF (JCIL.GT.0) WRITE(i_rpa,5017) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,14)
     *               ,(PAR(IP,I),SZ(I),I=35,37)
     *               ,(PAR(IP,I),SZ(I),I=15,16)
        ENDIF
      ENDIF     !ISTR
      IF (YES.and.iabs(Irf(IP)).eq.4) THEN
        WRITE(i_sum,1119)
     * (PAR(IP,I),SZ(I),I=1,5),(PAR(IP,I),SZ(I),I=12,19)
 1119 FORMAT(/' ==> OVERALL PARAMETERS:'//
     *       ' => Scale factors        : ',/,6(27x,2F11.6,/),/,
     *       ' => Extinction parameters: ',/,7(27x,2F11.6,/),/)
      endif
      IF(yes.and.iabs(irf(Ip)).ne.4) then
      if(iuvw.eq.1)
     *WRITE(i_sum,119) (PAR(IP,I),SZ(I),I=43,45)
  119 FORMAT(' => U,V,W for Lambda(2)  : ',/,3(27x,2F10.5,/),/)
      if(NPRO(IP).eq.5.or.NPRO(IP).gt.8)
     *WRITE(i_sum,118) PAR(IP,41),SZ(41),PAR(IP,42),SZ(42)
  118 FORMAT(' => Add. shape parameters: ',/,2(27x,2F10.5,/),/)
      endif
C
C  PRINTING additional Shift and Asymmetry parameters in case of JSOL(IP)<>0
C
      if(Jsol(IP).ne.0) then
      IF(CYE) then
      WRITE(i_out,'(//A/)')' => Additional Asymmetry & Shift Parameters'
      WRITE(i_out,'(A,a)')
     +'    Asymm   delta   Sigma   Shift1   delta   Sigma   Shift2   de'
     +,'lta   Sigma '
       WRITE(i_out,'((1X,5(3F8.4,1X)))')(PAR(IP,I),SY(I),SZ(I),I=38,40)
       WRITE(i_out,'(//)')
      endif
      IF (YES) THEN
      WRITE(i_sum,'(/A/)')' => Additional Asymmetry & Shift Parameters'
      WRITE(i_sum,'(22x,A)')' Asymmetry    Shift1    Shift2'
      WRITE(i_sum,'(22x,3F10.5/22x,3F10.5)')
     +         (PAR(IP,I),I=38,40),(SZ(I),I=38,40)
      endif
      ENDIF

C
C  PRINTING FURTHER PARAMETERS IN CASES ISTR><0 OR IFURT><0
C
      IF(ISMO(IP).GT.8) THEN
      IF(CYE) WRITE(i_out,'(//A//)') ' => Additional strain parameters:'
      IF(CYE) WRITE(i_out,1033)(PAR(IP,I),SY(I),SZ(I),I=21,25)
      IF(CYE) WRITE(i_out,'(//)')
        IF (YES) THEN
        WRITE(i_sum,'(/A/)') ' => Additional strain parameters ==>'
      WRITE(i_sum,'(5F10.5/5F10.5)') (PAR(IP,I),I=21,25),(SZ(I),I=21,25)
        endif
      ENDIF
      IF(ISTR(IP).EQ.1.OR.ISTR(IP).EQ.3) THEN
      IF(CYE) WRITE(i_out,'(//A//)')' => Generalized strain parameters:'
      IF(CYE) WRITE(i_out,1033)(PAR(IP,I),SY(I),SZ(I),I=18,22)
      IF(CYE) WRITE(i_out,'(//)')
      IF(CYE) WRITE(i_out,1033)(PAR(IP,I),SY(I),SZ(I),I=23,27)
 1033 FORMAT((1X,5(3F8.2,1X)))
      IF (YES) THEN
        WRITE(i_sum,'(/A/)') ' => Generalized strain parameters ==>'
      WRITE(i_sum,'(5F10.5/5F10.5)') (PAR(IP,I),I=18,22),(SZ(I),I=18,22)
      WRITE(i_sum,'(5F10.5/5F10.5)') (PAR(IP,I),I=23,27),(SZ(I),I=23,27)
      WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
      WRITE(i_rpa,'(A,5F10.5/A,5F10.5)')'GSTR ',(PAR(IP,I),I=18,22),
     +                                  'SIGM ', (SZ(I),I=18,22)
      WRITE(i_rpa,'(A,5F10.5/A,5F10.5)')'GSTR ', (PAR(IP,I),I=23,27),
     +                                  'SIGM ', (SZ(I),I=23,27)
        ENDIF
      ENDIF
      ENDIF
C
C  SIZE
C
      IF(ISTR(IP).GT.1) THEN
      IF(CYE)WRITE(i_out,'(//A//)')' => Generalized size parameters ==>'
      IF(CYE)WRITE(i_out,10333)(PAR(IP,I),SY(I),SZ(I),I=29,34)
10333 FORMAT(2X,9F12.4/2X,9F12.4)
      IF (YES) THEN
        WRITE(i_sum,'(/A/)') ' => Generalized size parameters ==>'
      WRITE(i_sum,'(6F10.4/6F10.4)') (PAR(IP,I),I=29,34),(SZ(I),I=29,34)
      WRITE(i_sum,'(A)')' '
        IF (JCIL.GT.0) THEN
      WRITE(i_sum,'(6F10.4/6F10.4)') (PAR(IP,I),I=29,34),(SZ(I),I=29,34)
        ENDIF
      ENDIF
      ENDIF
C
C  PARAMETERS DEFINED BY USER
C
      IF(IFURT(IP).GT.0) THEN
      IFP=IFURT(IP)
      IF(CYE) WRITE(i_out,'(//A/a)')
     +  ' => Further parameters defined by user==>',
     +  '  Name       Value         Shift         Sigma'
      IF (YES)
     * WRITE(i_sum,'(/A/a)')' => Further parameters defined by user ==>'
     * , '     Name       Value         Sigma'
      DO 378 I=1,IFP
      IF(CYE)
     * WRITE(i_out,'((1X,A4,3F14.6))') NAMEF(IP,I),PAR(IP,I+LASTMPAR),
     *                             SY(I+LASTMPAR),SZ(I+LASTMPAR)
        IF (YES) THEN
      WRITE(i_sum,'((5X,A4,2F14.6))') NAMEF(IP,I),PAR(IP,I+LASTMPAR),
     *                                SZ(I+LASTMPAR)
         IF (JCIL.GT.0) THEN
      WRITE(i_rpa,'(A4,2F14.6)') NAMEF(IP,I),PAR(IP,I+LASTMPAR),
     *                           SZ(I+LASTMPAR)
         ENDIF
        ENDIF
  378 continue
        IF(YES) WRITE(i_sum,'(A)')' '
      ENDIF
       return
       end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      Subroutine Mag_write(n,ip,iof,npout,ispher,cye,yes,jpout,shf)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/F1/SMM(MSZ,MSZ),V(MSZ)
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      Common/Rfactor/freed,freed1,chi2,cchi2
      DIMENSION SMOM(3),COSA(3),COR1(3,3),DSPH(3,3)
      DIMENSION SY(MPAR),SZ(MPAR)
      DIMENSION JPOUT(MSZ),SHF(MSZ),SINA(3),SMOI(3)
      common/anakm/iana(msz)
      LOGICAL YES,cye,skip
      DATA RAD/1.7453293E-02/
c--------------------------------------------
c   MAGNETIC WRITINGS AND CALCULATIONS
c--------------------------------------------
c
      If(iabs(jbt(ip)).eq.5) then
         IF(CYE) WRITE(i_out,7011)
         IF(YES) WRITE(i_sum,7012)
         jin=6
         jfin=15
       elseIF(ISPHER.EQ.0) THEN
         jin=6
         jfin=12
       IF(CYE) WRITE(i_out,4346)
       IF (YES) WRITE(i_sum,2015)
          ELSE
         jin=6
         jfin=12
       IF(CYE) WRITE(i_out,4846)
       IF (YES) WRITE(i_sum,2115)
      ENDIF
C
C Magnetic Formats
C
4346  FORMAT(//' => Magnetic moment parameters, shifts, and ',
     *'standard deviations'//' Atom',4X,'Mx',5X,'dMx',4X,'sMx',5X,
     *'My',5X,'dMy',4X,'sMy',5X,'Mz',5X,'dMz',4X,'sMz',5X,' M',9X,
     *'sM','    MPhas  dMPhas sMPhas ')
 2015 FORMAT(/1X,'==> MAGNETIC MOMENT PARAMETERS:'//1X,
     &' Name   Mx    sMx    My    sMy    Mz    sMz       M',
     &'    sM     MPhas   sMPhas'/)
4846  FORMAT(//' => Magnetic moment parameters, shifts, and ',
     *'standard deviations'//' Atom',5X,'Mom',5X,'dMo',5X,'sMo',6X,
     *'Ph',6X,'dPh',5X,'sPh',5X,'Tet',6X,'dTe',5X,'sTe',1X,
     *'   MPhas  dMPhas sMPhas ')
 2115 FORMAT(/1X,'==> MAGNETIC MOMENT PARAMETERS:'//1X,
     &' Name    Mom     sMo     Phi     sPhi     Tet     sTet',
     &'     MPhas   sMPhas'/1x,
     &'         Mx      sMx      My      sMy      Mz      sMz'/)
 7011 FORMAT(/ ' =>   User-defined Magnetic Parameters :'/' Atom',
     *7X,' P6',6X,' dP6',6X,' sp6',7X,' P7',6X,' dP7',6X,' sp7',
     *7X,' P8',6X,' dP8',6X,' sp8'/12X,' P9',6X,' dP9',6X,' sp9',
     *7X,'P10',6X,'dP10',6X,'sP10',7X,'P11',6X,'dP11',6X,'sP11'/
     *12X,'P12',6X,'dP12',6X,'sP12',7X,'P13',6X,'dP13',6X,'sP13',
     *7X,'P14',6X,'dP14',6X,'sP14'/12X,'P15',6X,'dP15',6X,'sP15'/)
c
 7012 FORMAT(/1X,'==>  USER-DEFINED MAGNETIC PARAMETERS'//
     &' Name     P6       P7        P8        P9       P10       P11'/
     &'         sP6      sP7       sP8       sP9      sP10      sP11'/
     &'         P12      P13       P14       P15                   '/
     &'        sP12     sP13      sP14      sP15     '/)

C
      DO 24 I=1,N
      ipiof=I+IOF
      skip=.false.
      if(n_t(ipiof).eq.0.or.n_t(ipiof).eq.2) goto 24
      IKPIO=IKV(IPIOF)
      IF(IKPIO.NE.0) THEN
       IKPIA=IABS(IKPIO)
       IF(IKPIO.LT.0.AND.GENK(IP).EQ.'Y') IKPIO=NVK(IP)/2+IKPIA
       IF(IKPIO.LT.0.AND.GENK(IP).NE.'Y') IKPIO=1+IKPIA
       if(IBZ(IP,ikpio).eq.1) skip=.true.
      endif
      DO 25 J=jin,jfin
      KM=LP(I+IOF,J)
      IF(KM.NE.0)GOTO 26
      SY(J)=0.
      SZ(J)=0.
      GOTO  25
   26 SZ(J)=SQRT(ABS(SMM(KM,KM)))
      SY(J)=V(KM)*A(I+IOF,J)*RELAX(1)
      if(NRELL.eq.0.or.km.gt.MAXS) then
       XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
      else
       call limite(XL(I+IOF,J),SY(J),A(I+IOF,J),KM,npout,Jpout,SHF)
      endif
       if(j.gt.6.and.j.ne.9.and.j.ne.12.and.ISPHER.EQ.1)
     +                 XL(I+IOF,J)=AMOD(XL(I+IOF,J),360.)
       IF(JBT(IP).EQ.5.AND.(J.EQ.7.OR.J.GT.8))
     +                 XL(I+IOF,J)=AMOD(XL(I+IOF,J),360.)
       IF(JBT(IP).ne.5.AND. J.EQ.12 ) xl(i+iof,j)=AMOD(XL(I+IOF,J),1.)
   25 CONTINUE
C
C  MAGNETIC MOMENT CALCULATION
C
      If(iabs(jbt(ip)).eq.5) goto  867
 825  DO 718 J=1,3
      COSA(J)=COS(SAVE(IP,J+3)*RAD)
 718  SINA(j)=SQRT(1.0-COSA(J)*COSA(J))
      csi=COSA(3)/SINA(3)
c
c  Apply constraints for the case JHELIX(ip)=1
c
       IF(jbt(IP).eq.1.and.JHELIX(IP).EQ.1.and.lp(ipiof,8).ne.0) THEN
         x=XL(ipiof,6)*XL(ipiof,9)+XL(ipiof,7)*XL(ipiof,10)
         x=x+(XL(ipiof,6)*XL(ipiof,10)+XL(ipiof,7)*XL(ipiof,9))*cosa(3)
         x=x+XL(ipiof,8)*(XL(ipiof,9)*cosa(2)+XL(ipiof,10)*cosa(1))
         x1=XL(ipiof,8)+cosa(2)*XL(ipiof,6)+cosa(1)*XL(ipiof,7)
         XL(IPIOF,11)=-x/x1
       ENDIF

       IF(jbt(IP).eq.-1.and.JHELIX(IP).EQ.1.and.lp(ipiof,7).ne.0) THEN
          if(abs(XL(ipiof,8)-XL(ipiof,11)).GT.90.0) THEN
           XL(IPIOF,11)=XL(ipiof,8)+90.
           XL(IPIOF,10)=XL(IPIOF,7)
         else
           x1=cos(XL(ipiof,8)*rad)/sin(XL(ipiof,8)*rad)
           x2=cos(XL(ipiof,11)*rad)/sin(XL(ipiof,11)*rad)
           XL(IPIOF,10)=XL(IPIOF,7)+ACOS(-X1*X2)/rad
         endif
       ENDIF

c
      IF(ISPHER.EQ.1) GOTO 827
      YY=0.
      Z=0.
      DO 721 J=1,3
      K=J+1
      IF(K.GT.3)K=K-3
      L=K+1
      IF(L.GT.3)L=L-3
  721 SMOM(J)=XL(I+IOF,J+5)+XL(I+IOF,L+5)*COSA(K)+XL(I+IOF,K+5)*COSA(L)

      DO 722 J=1,3
      LPJ=LP(I+IOF,J+5)
      DO 722 K=1,3
      LPK=LP(I+IOF,K+5)
      X1=0.
      IF(.NOT.((LP(I+IOF,J+5).EQ.0).OR.(LP(I+IOF,K+5).EQ.0)))
     &             X1=SMM(LPJ,LPK)*A(I+IOF,J+5)*A(I+IOF,K+5)
      X2=1.
      JK=6-J-K
      IF(J.NE.K)X2=COSA(JK)
      YY=YY+XL(I+IOF,J+5)*XL(I+IOF,K+5)*X2
  722 Z=Z+SMOM(J)*SMOM(K)*X1

      IF(Z.LT.0.0.OR.YY.LE.0) THEN
      call mess(' Something is going wrong in magnetic moment!')
         Z=ABS(Z)
         YY=ABS(YY)
         if(yy.lt.1.e-10) yy=1.0e-10
      ENDIF
      Z=SQRT(Z/YY)
      YY=SQRT(YY)

      IF(YES)WRITE(i_sum,1023)ATEXT(I+IOF),
     * (XL(I+IOF,J),INT(SZ(J)*1000.),J=6,8),YY,INT(10000.*Z),
     * XL(I+IOF,12),INT(SZ(12)*10000.)
      IF (YES.AND.JCIL.GT.0) then
      WRITE(i_rpa,'(a,a4,5f10.5)')'MOMR ', ATEXT(I+IOF),
     +                (XL(I+IOF,J),J=6,8),YY,XL(I+IOF,12)
      WRITE(i_rpa,'(a,5f10.5)')'SIGM     ',(SZ(J),J=6,8),Z,SZ(12)
      endif

      IF(CYE) WRITE(i_out,1081)
     + ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,8),
     * YY,Z,XL(I+IOF,12),SY(12),SZ(12)
 1023 FORMAT(1X,A4,1X,3(F7.3,'(',I3,')',1X),2x,2(F7.4,'(',I4,')',3X))
 1081 FORMAT(1X,A4,2X,3(3F7.3,1X),2(F8.4,1X),3F7.4)

C  Writing imaginary part of the Fourier coefficients in crystallographic
C  frame (in units of Bohr magnetons)
      if(skip) goto 24
      if(ianis(ip).eq.2) then
      YY=0.
      Z=0.
      DO J=1,3
      K=J+1
      IF(K.GT.3)K=K-3
      L=K+1
      IF(L.GT.3)L=L-3
      SMOI(J)=XL(I+IOF,J+8)+XL(I+IOF,L+8)*COSA(K)+XL(I+IOF,K+8)*COSA(L)
      End do
      DO  J=1,3
      LPJ=LP(I+IOF,J+8)
       DO  K=1,3
        LPK=LP(I+IOF,K+8)
        X1=0.
        IF(.NOT.((LP(I+IOF,J+8).EQ.0).OR.(LP(I+IOF,K+8).EQ.0)))
     &             X1=SMM(LPJ,LPK)*A(I+IOF,J+8)*A(I+IOF,K+8)
        X2=1.
        JK=6-J-K
        IF(J.NE.K)X2=COSA(JK)
        YY=YY+XL(I+IOF,J+8)*XL(I+IOF,K+8)*X2
        Z=Z+SMOI(J)*SMOI(K)*X1
        end do
        end do
      IF(abs(YY).lt.1.e-12) THEN
         Z=0.0
         YY=0.0
      else
        Z=SQRT(abs(Z)/YY)
        YY=SQRT(YY)
      ENDIF

      IF(YES)WRITE(i_sum,1120)
     * (XL(I+IOF,J),INT(SZ(J)*1000.),J=9,11),YY,INT(10000.*Z)

      IF (YES.AND.JCIL.GT.0) then
      WRITE(i_rpa,'(a,a4,4f10.5)')'MOMI ', ATEXT(I+IOF),
     +                (XL(I+IOF,J),J=9,11),YY
      WRITE(i_rpa,'(a,4f10.5)')'SIGM     ',(SZ(J),J=9,11),Z
      endif

      IF(CYE) WRITE(i_out,1182) (XL(I+IOF,J),SY(J),SZ(J),J=9,11)
     *,YY,Z,XL(I+IOF,12),SY(12),SZ(12)

 1120 FORMAT(6X,3(F7.3,'(',I3,')',1X),2x,F7.4,'(',I4,')',
     *'-> Imag. components')
 1182 FORMAT(7X,3(3F7.3,1X),2(F8.4,1X),3F7.4,'-> Imaginary components')

      endif

      GOTO 24
C
C WRITE MAGNETIC PARAMETERS FOR JBT=-1 (SPHERICAL COORDINATES)
C
C********1*********2*********3*********4*********5*********6*********7**
  827  IF(CYE) WRITE(i_out,'(1X,A4,2X,3(3F8.3,1X),3F7.4)')
     * ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,8),
     * XL(I+IOF,12),SY(12),SZ(12)

       IF(YES)
     * WRITE(i_sum,712)
     * ATEXT(I+IOF),(XL(I+IOF,J),SZ(J),J=6,8),
     * XL(I+IOF,12),INT(SZ(12)*10000.)

  712  FORMAT(1X,A4,1X,3(F8.3,'(',F6.3,')',1X),2x,F7.4,'(',I4,')')

       IF(YES.AND.JCIL.GT.0) then
      WRITE(i_rpa,'(a,a4,4f10.5)')'SPHR ', ATEXT(I+IOF),
     +                (XL(I+IOF,J),J=6,8),XL(I+IOF,12)
      WRITE(i_rpa,'(a,4f10.5)')'SIGM     ',(SZ(J),J=6,8),SZ(12)
       endif
c
c  Calculation of the x,y,z components of the magnetic moment of atom I
c  as a function of its spherical components.
c  Here SMOM is the magnetic moment vector!.After writing, SZ will be
c  the standard deviations of the x,y,z components of SMOM.
c
      IF(YES) THEN

      IPIOF=I+IOF
      cs7=COS(XL(IPIOF,7)*RAD)     !PHI
      sc7=SIN(XL(IPIOF,7)*RAD)
      cs8=COS(XL(IPIOF,8)*RAD)     !THETA
      sc8=SIN(XL(IPIOF,8)*RAD)
      CMx=XL(IPIOF,6)*CS7*SC8
      CMy=XL(IPIOF,6)*SC7*SC8
      SMOM(1)=CMx-CMy*csi
      SMOM(2)=CMy/SINA(3)
      SMOM(3)=XL(IPIOF,6)*CS8
      X1=XL(I+IOF,6)*RAD*SC8
      X2=XL(I+IOF,6)*RAD*CS8
      DSPH(1,2)= -X1*(SC7+CS7*csi)   !DERIVATIVES W.R.T.PHI
      DSPH(2,2)= X1*CS7/SINA(3)
      DSPH(3,2)=0.0
      DSPH(1,3)=X2*(CS7-SC7*CSI)     !DERIVATIVES W.R.T.THETA
      DSPH(2,3)=X2*SC7/SINA(3)
      DSPH(3,3)=-X1
C
C Calculation of standard deviations of SMOM(j)
C
       DO J=1,3
       LPJ=LP(I+IOF,J+5)
       if(abs(xl(i+iof,6)).lt.1.e-12) then
         DSPH(J,1)=0.0
        else
         DSPH(J,1)=SMOM(J)/XL(I+IOF,6)
       endif
       DO K=1,3
       LPK=LP(I+IOF,K+5)
       X1=0.0
      IF(.NOT.((LPJ.EQ.0).OR.(LPK.EQ.0)))
     &             X1=SMM(LPJ,LPK)*A(I+IOF,J+5)*A(I+IOF,K+5)
       COR1(J,K)=X1
       END DO
       END DO
C
        DO J=1,3
        SZ(J)=0.0
         DO L=1,3
          X1=0.0
           DO K=1,3
           X1=X1+COR1(L,K)*DSPH(J,K)
           END DO
          SZ(J)=SZ(J)+X1*DSPH(J,L)
         END DO
        SZ(J)=SQRT(ABS(SZ(J)))
        END DO
       WRITE(i_sum,1123)
     * '    ',(SMOM(J),SZ(J),J=1,3)
 1123 FORMAT(1X,A4,1X,3(F8.3,'(',F6.3,')',1X))
      ENDIF  !if (yes)
C
C  Writing imaginary part of the Fourier coefficients in SPHERICAL
C  coordinates and crystallographic frame (in units of Bohr magnetons)
      if(skip) goto 24
      if(ianis(ip).eq.2) then

       IF(CYE) WRITE(i_out,'(7X,3(3F8.3,1X),a)')
     * (XL(I+IOF,J),SY(J),SZ(J),J=9,11),'-> Imaginary components'

       IF(YES) WRITE(i_sum,523) (XL(I+IOF,J),SZ(J),J=9,11)
  523  FORMAT(6X,3(F8.3,'(',F6.3,')',1X),'-> Imag. components')

       IF(YES.AND.JCIL.GT.0) then
      WRITE(i_rpa,'(a,a4,3f10.5)')'SPHI ', ATEXT(I+IOF),
     +                (XL(I+IOF,J),J=9,11)
      WRITE(i_rpa,'(a,3f10.5)')'SIGM     ',(SZ(J),J=9,11)
       endif
c
c  Calculation of the x,y,z components of the magnetic moment of atom I
c  as a function of its spherical components. Imaginary components
c  Here SMOI is the magnetic moment vector!.After writing, SZ will be
c  the standard deviations of the x,y,z components of SMOM.
c
      IF(YES) THEN      !Imaginary components

      IPIOF=I+IOF
      cs7=COS(XL(IPIOF,10)*RAD)     !PHI
      sc7=SIN(XL(IPIOF,10)*RAD)
      cs8=COS(XL(IPIOF,11)*RAD)     !THETA
      sc8=SIN(XL(IPIOF,11)*RAD)
      CMx=XL(IPIOF,9)*CS7*SC8
      CMy=XL(IPIOF,9)*SC7*SC8
      SMOI(1)=CMx-CMy*csi
      SMOI(2)=CMy/SINA(3)
      SMOI(3)=XL(IPIOF,9)*CS8
      X1=XL(I+IOF,9)*RAD*SC8
      X2=XL(I+IOF,9)*RAD*CS8
      DSPH(1,2)= -X1*(SC7+CS7*csi)   !DERIVATIVES W.R.T.PHI
      DSPH(2,2)= X1*CS7/SINA(3)
      DSPH(3,2)=0.0
      DSPH(1,3)=X2*(CS7-SC7*CSI)     !DERIVATIVES W.R.T.THETA
      DSPH(2,3)=X2*SC7/SINA(3)
      DSPH(3,3)=-X1
C
C Calculation of standard deviations of SMOI(j)
C
       DO J=1,3
       LPJ=LP(I+IOF,J+8)
       if(abs(xl(i+iof,9)).lt.1.e-12) then
        DSPH(J,1)=0.0
       else
        DSPH(J,1)=SMOI(J)/XL(I+IOF,9)
       endif
       DO K=1,3
       LPK=LP(I+IOF,K+8)
       X1=0.0
      IF(.NOT.((LPJ.EQ.0).OR.(LPK.EQ.0)))
     &             X1=SMM(LPJ,LPK)*A(I+IOF,J+8)*A(I+IOF,K+8)
       COR1(J,K)=X1
       END DO
       END DO
C
        DO J=1,3
        SZ(J)=0.0
         DO L=1,3
          X1=0.0
           DO K=1,3
           X1=X1+COR1(L,K)*DSPH(J,K)
           END DO
          SZ(J)=SZ(J)+X1*DSPH(J,L)
         END DO
        SZ(J)=SQRT(ABS(SZ(J)))
        END DO
       WRITE(i_sum,1523) (SMOI(J),SZ(J),J=1,3)
 1523 FORMAT(6X,3(F8.3,'(',F6.3,')',1X),'-> Imag. components'/)
      ENDIF

      endif

      goto 24
c-------------------------------------------------------------------------
c  Writing for JBT=5,-5
c-------------------------------------------------------------------------
c
  867  IF(CYE)WRITE(i_out,77)
     + ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,15)
   77 FORMAT(1X,A4,9F10.6,/5X,9F10.6/5X,9F10.6/5X,9F10.6)
       IF(YES)WRITE(i_sum,778)ATEXT(I+IOF),(XL(I+IOF,J),J=6,11),
     + (SZ(J),J=6,11),(XL(I+IOF,J),J=12,15),
     + (SZ(J),J=12,15)
  778 FORMAT(1X,A4,6(1X,F9.4)/5X,6(1X,F9.4)/5X,4(1X,F9.4)/5X,4(1X,F9.4))
c
c
c-------------------------------------------------------------------------
   24 CONTINUE    !End loop over atoms, index I
c-------------------------------------------------------------------------
c
C
C  SUMS OVER CONSTRAINTS
C

      IF(NMAGC(IP).NE.0) THEN
      X1=CHI2*SUMACM(IP)*NAPCM(IP)
      RATX1=X1/S2
      IF(CYE)WRITE(i_out,'(/A/A,I2,A,G12.3,4X,A,F12.5/A,G12.3/A,G12.3)')
     *' => Slack Constraints(mag):',
     *'         Sum{W(Mobs-Mcal)**2}/',NAPCM(IP),' =',SUMACM(IP),
     *' SM/S2 =',RATX1,
     *'    SM=Chi2*Sum{W(Mobs-Mcal)**2} =',X1,
     *'    S2=     Sum{w(yobs-ycal)**2} =',S2
      IF(CYE) WRITE(i_out,'(A,I2,A,F10.4)')
     *'   Rms=Sqrt{Sum[Mobs-Mcal]**2/',NAPCM(IP),'}=',RMSM(IP)
      IF(YES) THEN
      WRITE(i_sum,'(/A/A,I2,A,G12.3,4X,A,F12.5/A,G12.3/A,G12.3)')
     *' => Slack Constraints(mag):',
     *'         Sum{W(Mobs-Mcal)**2}/',NAPCM(IP),' =',SUMACM(IP),
     *' SM/S2 =',RATX1,
     *'    SM=Chi2*Sum{W(Mobs-Mcal)**2} =',X1,
     *'    S2=     Sum{w(yobs-ycal)**2} =',S2
      WRITE(i_sum,'(A,I2,A,F10.4)')
     *'   Rms=Sqrt{Sum[Mobs-Mcal]**2/',NAPCM(IP),'}=',RMSM(IP)
      ENDIF
      ENDIF
c-------------------------------------------------------------------------
C   END OF MAGNETIC WRITING
c-------------------------------------------------------------------------
      return
      END
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine calc_rfac(icycle)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/G3/COND,IORD1,IORD2,TH,NUM,NUM1
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      COMMON/G22/ES1,ES2,ES3,ED1,ED2,ER1,ER2,ER3,EDEVINC,EYINV,
     +           EDW,EQQ1,EQQ2,EQQ3
      Common/Rfactor/freed,freed1,chi2,cchi2
      real*4 N_sb,N_st
      common/rx_fac/rx1,rx11,qdw,devinc,dstar,qdw1,edstar,N_sb,N_st
      call mess(' ')
      call message(' CYCLE No.:',ICYCLE,0.,1)
      FREED=FLOAT(NUM)-FLOAT(MAXS)         !All points
      FREED1=FLOAT(NUM1)-FLOAT(MAXS)       !Points with Bragg contributions
      RX1=100.*SQRT(FREED/D2)              !Expected
      RX11=100.*SQRT(FREED1/ED2)
      DEVINC=DEV
      CHI2=(R3/RX1)**2              !All points
      CCHI2=(ER3/RX11)**2           !Points with Bragg contributions
      CCS=FREED+YINV
      CCS1=FREED1+EYINV
      DSTAR=DEVINC/CCS
      EDSTAR=EDEVINC/CCS1
      QDW=2.0*(FLOAT(NUM-1)/FREED-3.0902/SQRT(FLOAT(NUM+2)))
      QDW1=2.0*(FLOAT(NUM1-1)/FREED1-3.0902/SQRT(FLOAT(NUM1+2)))
      N_sb=(cchi2-1.0)*sqrt(FREED1*0.5)
      N_st=(chi2-1.0)*sqrt(FREED*0.5)
      return
      end
c-----------------------------------------------------------------------
      subroutine Write_R_factors(cye,yes,icycle,taf)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/G3/COND,IORD1,IORD2,TH,NUM,NUM1
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      COMMON/G22/ES1,ES2,ES3,ED1,ED2,ER1,ER2,ER3,EDEVINC,EYINV,
     +           EDW,EQQ1,EQQ2,EQQ3
      Common/Rfactor/freed,freed1,chi2,cchi2
      real*4 N_sb,N_st
      common/rx_fac/rx1,rx11,qdw,devinc,dstar,qdw1,edstar,N_sb,N_st
      LOGICAL YES,cye
      CHARACTER TAF*4,strings*80
C
C   Writing Reliability factors
C
      IF(CYE) then
      WRITE(i_out,'(/A/)')
     + ' ==> RELIABILITY FACTORS WITH ALL NON-EXCLUDED POINTS:'
      WRITE(i_out,57)R2,R3,CHI2,DW
   57 FORMAT(' => R-Factors: ',2G9.3,' Chi2: ',G10.3,' DW-Stat.: ',F8.4)
      WRITE(i_out,58)RX1,QDW
   58 FORMAT(' => Expected : ',9X,G9.3,28X,F8.4)
      WRITE(i_out,59)DEVINC,DSTAR
   59 FORMAT(' => Deviance :',G9.3,4X,' Dev*: ',G10.4)
      WRITE(i_out,66) SQRT(S2/FLOAT(NUM))
   66 FORMAT(' => GoF-index:',G8.2,5X,'Sqrt(Residual/N)')
      endif
      call clear_string(strings)
      WRITE(strings,57)R2,R3,CHI2,DW
      call mess(strings)
      call clear_string(strings)
      WRITE(strings,58)RX1,QDW
      call mess(strings)
      IF (YES) WRITE(i_sum,1022)ICYCLE,MCYCLE
 1022 FORMAT(/' ==> RELIABILITY FACTORS WITH ALL NON-EXCLUDED POINTS:'//
     &        ' => Cycle:',I3,1X,'=> MaxCycle:',I3)
      I=NUM-MAXS
      IF(CYE) WRITE(i_out,62)I
      IF (YES) WRITE(i_sum,62)I
      IF(CYE) WRITE(i_out,63)S1,D1,S3,D2,S2,COND
      X=100.*SQRT(FREED/QQ2)
      CHI=(QQ3/X)**2
      IF(CYE) WRITE(i_out,5100)R1,QQ3,X,CHI,QQ1,QQ2
 5100 FORMAT(/' => Conventional Rietveld Rp,Rwp,Re and Chi2: ',3G9.3,
     &G10.4/  ' => (Values obtained using Ynet, but true sigma(y))'/
     &        ' =>  SumYnet, Sum(w Ynet**2): ',2G14.4/)
      call mess(' Conventional Rietveld R-factors ==>')
      call clear_string(strings)
      WRITE(strings,'(a,g9.3,a,g9.3,a,f8.2,a,g10.3)')
     + ' => Rp:',R1,' Rwp:',QQ3,' Rexp:',X,' Chi2:',CHI
      call mess(strings)
      IF (YES) THEN
       WRITE(i_sum,1021)R2,R3,RX1,CHI2,TAF
 1021 FORMAT(' => Rp:',G9.3,1X,'Rwp:',G9.3,1X,'Rexp:',F8.2,1X,
     * 'Chi2:',G10.3,2X,A4,' refinement')
       WRITE(i_sum,5106)R1,QQ3,X,CHI
 5106 FORMAT(' => Conventional Rietveld R-factors ==>'/
     *       ' => Rp:',G9.3,' Rwp:',G9.3,' Rexp:',F8.2,' Chi2:',G10.3)
       WRITE(i_sum,1159)DEVINC,DSTAR,DW,QDW
 1159 FORMAT(' => Deviance: ',G9.3,4X,' Dev*  : ',G10.4/
     &       ' => DW-Stat.: ',F9.4,4X,' DW-exp: ',F10.4)
      IF(JCIL.GT.0) then
        WRITE(i_rpa,'(a,4g10.4)')   'RFAR ',R2,R3,RX1,CHI2
        WRITE(i_rpa,'(a,4g10.4,i8)')'RFAC ',R1,QQ3,X,CHI,i
        WRITE(i_rpa,'(a,4g10.4)')   'DEVA ',DEVINC,DSTAR,DW,QDW
      endif
      write(i_out,'(a,f8.3)')' => N-sigma of the GoF: ', N_st
      write(i_sum,'(a,f8.3)')' => N-sigma of the GoF: ', N_st
      ENDIF
   62 FORMAT(' => N-P+C: ',I5)
   63 FORMAT(/' =>  SumYdif', 7X,'SumYobs', 6X,'SumYcal', 6X,
     *'SumwYobsSQ','  Residual',6X,'Condition'/1X,6G14.4/)
c----------------------------
      IF(CYE) then
      WRITE(i_out,'(/A/)')
     + ' ==> RELIABILITY FACTORS FOR POINTS WITH BRAGG CONTRIBUTIONS:'
       WRITE(i_out,57)ER2,ER3,CCHI2,EDW
       WRITE(i_out,58)RX11,QDW1
       WRITE(i_out,59)EDEVINC,EDSTAR
       WRITE(i_out,66) SQRT(ES2/FLOAT(NUM1))
      endif
      IF (YES) WRITE(i_sum,'(/A/)')
     + ' ==> RELIABILITY FACTORS FOR POINTS WITH BRAGG CONTRIBUTIONS:'
      I=NUM1-MAXS
      IF(CYE) WRITE(i_out,62)I
      IF (YES) WRITE(i_sum,62)I
      IF(CYE) WRITE(i_out,63)ES1,ED1,ES3,ED2,ES2,COND
      X=100.*SQRT(FREED1/(EQQ2))
      CHI=(EQQ3/X)**2
      IF(CYE) WRITE(i_out,5100)ER1,EQQ3,X,CHI,EQQ1,EQQ2
      IF (YES) THEN
       WRITE(i_sum,1021)ER2,ER3,RX11,CCHI2,TAF
       WRITE(i_sum,5106)ER1,EQQ3,X,CHI
       WRITE(i_sum,1159)EDEVINC,EDSTAR,EDW,QDW1
       IF(JCIL.GT.0) then
        WRITE(i_rpa,'(a,4g10.4)')   'RFBR ',ER2,ER3,RX11,CCHI2
        WRITE(i_rpa,'(a,4g10.4,i8)')'RFBC ',ER1,EQQ3,X,CHI,i
        WRITE(i_rpa,'(a,4g10.4)')   'DEVB ',EDEVINC,EDSTAR,EDW,QDW1
       ENDIF
      write(i_out,'(a,f12.3)')' => N-sigma of the GoF: ', N_sb
      write(i_sum,'(a,f12.3)')' => N-sigma of the GoF: ', N_sb
      ENDIF
      return
      end
c-----------------------------------------------------------------------
      subroutine limite(x,dx,COR,km,npout,jpout,SHF)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      DIMENSION JPOUT(MSZ),SHF(MSZ)
      common/anakm/iana(msz)
       if(Numpar(KM).eq.0) then
         X=X+dx
       else
        if(iana(km).eq.1)then
          X=X+SHF(km)*COR
        else
          iana(km)=1
          Xaux=X+dx
         if(Xaux.lt.Vlim1(km)) then
           NPOUT=NPOUT+1
           JPOUT(NPOUT)=-KM
           SHF(km)=Vlim1(km)-X
           X=Vlim1(km)
         else if(Xaux.gt.Vlim2(km)) then
           NPOUT=NPOUT+1
           JPOUT(NPOUT)=KM
           SHF(km)=Vlim2(km)-X
           X=Vlim2(km)
         else
           iana(km)=1
           X=Xaux
           SHF(KM)=dx
         endif
        endif
       endif
       return
       end
c-----------------------------------------------------------------------
      subroutine Plimite(yes,npout,jpout)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      DIMENSION JPOUT(MSZ),iya(msz)
      logical yes
      WRITE(i_out, '(/a/)')
     +' => WARNING!! the following parameters have gone out of limits!'
      if(yes)  WRITE(i_sum, '(/a/)')
     +' => WARNING!! the following parameters have gone out of limits!'
      do 10 i=1,npout
       j=iabs(jpout(i))
       iya(i)=j
         do k=i-1,1,-1
          if(j.eq.iya(k)) goto 10
         end do
       fixed=VLIM1(j)
       if(jpout(i).gt.0) fixed=VLIM2(j)
       if(yes) then
       WRITE(i_sum,'(a,i3,a,f10.4)')
     +  '  -> Parameter no.: ',iabs(jpout(i)), ' Fixed to: ',fixed
       endif
       WRITE(i_out,'(a,i3,a,f10.4)')
     +  '  -> Parameter no.: ',iabs(jpout(i)), ' Fixed to: ',fixed
 10   continue
      WRITE(i_out,'(a)') ' '
      if(yes)  WRITE(i_sum,'(a)') ' '
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE ShelxF
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3) !1->24 Oh, 25->36 D6h
C     DIMENSION IM(3,3),TS(3),jti(16),zpp(16)
      DIMENSION IM(3,3),TS(3),zpp(16)
      real*4 Ltr,lamb
      common/Latda/Nlat,in,Ltr(4,3)
      CHARACTER SPG(20)*1,strsym*50
      dimension lata(7)
      data lata/1,5,6,7,2,3,4/
      isx=i_shx
      call OpenFile(17,0,1)
      Write(isx,'(A,A66)')'TITL ',TITLE
      K=1
      IOF=0
      izet=1
      sigg=0.001
      lamb=lamda(1)
      if(iabs(irf(K)).eq.4) lamb=R_lambda(K)
      write(isx,'(a,f8.4,6f10.4)')'CELL ',lamb,(PAR(K,I),I=6,11)
      write(isx,'(a,i4,6f10.4)')'ZERR ',izet,sigg,sigg,sigg,0.0,0.0,0.0
      DO  I=1,20
        SPG(I)=SYMB(K,I)
      END DO
      CALL LATSYM(SPG)
      isin=1
      if(icet(k).eq.1) isin=-1
      write(isx,'(a,i3)')'LATT ',isin*Lata(in)
C
C  WRITE SYMMETRY OPERATORS
C
      MULTG=MLTG(K)
      DO 10 IR=2,MULTG
        II=IABS(IVEC(K,IR))
        ISS=IVEC(K,IR)/II
        DO 301 J=1,3
         TS(J)=TR(K,IR,J)
        DO 301 L=1,3
        IM(J,L)=ISS*MOD6(II,J,L)
  301 CONTINUE
      call StringSym(IM,TS,strsym)
      Write(isx,'(a,a)')'SYMM ',strsym
   10 CONTINUE
      RMU=0.0
      RADI=1.2
      nti=1
       do i=1,16
C       jti(i)=0
        zpp(i)=0.0
       end do
      do 20 i=1,natom(k)
      ni=ptr(I+iof,1)
      zfac=xl(i+iof,5)*MULTG*icet(k)*nlat
      zpp(ni)=zpp(ni)+zfac
      if(i.gt.1) then
       do j=i-1,1,-1
        if(ni.eq.ptr(j,1)) goto 20
       end do
      endif
      Write(isx,'(a,A4,1X,9F8.4,a/6x,4f8.4)')'SFAC ',NAM(NI),
     + (AC(J,NI),J=1,9),' =',DFP(NI),DFPP(NI),RMU,RADI
      nti=nti+1
  20  CONTINUE
C
      WRITE(isx,'(a,16i4)')'UNIT ',(Int(zpp(j)),j=1,nti-1)
      write(isx,'(a)') 'HKLF 3'
      write(isx,'(a)') 'OMIT  '
      write(isx,'(a)') 'L.S.  3 '
      write(isx,'(a)') 'WGHT  0.000 '
      write(isx,'(a)') 'FMAP  2  -3  28  60  0 '
      write(isx,'(a)') 'GRID -2  -2  -2   2   2   2'
      write(isx,'(a)') 'FVAR  1.0'
      WRITE(isx,'(A4,1x,I2,1X,5F12.5)' )
     +(ATEXT(I+IOF),PTR(I+IOF,1),(XL(I+IOF,J)+10.0,J=1,3),
     +XL(I+IOF,5)+10.0,XL(I+IOF,4)/78.956835+10.0 ,I=1,NATOM(K))
C
      write(isx,'(a)') 'END  '
      close(unit=isx)
      RETURN
      END
C*****************************************************************
c-----------------------------------------------------------------------
      SUBROUTINE Fourier_Template
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3) !1->24 Oh, 25->36 D6h
      DIMENSION IM(3,3),TS(3)
      CHARACTER strsym*50
      isx=i_shx
      call OpenFile(17,1,1)
      Write(isx,'(A4,6x,A68)')'TITL',TITLE
      K=1
      IOF=0
      write(isx,'(a4,6x,6f10.4)')'CELL',(PAR(K,I),I=6,11)
c
c  Write atom positions
c
      WRITE(isx,'(A4,6x,A4,6x,3F10.5)' )
     +('PXYZ',ATEXT(I+IOF),(XL(I+IOF,J),J=1,3),I=1,NATOM(K))
C
C  Write symmetry operators
C
      MULTG=MLTG(K)
      DO 10 IR=2,MULTG
        II=IABS(IVEC(K,IR))
        ISS=IVEC(K,IR)/II
        DO  J=1,3
         TS(J)=TR(K,IR,J)
         DO  L=1,3
          IM(J,L)=ISS*MOD6(II,J,L)
         end do
        end do
      call StringSym(IM,TS,strsym)
      Write(isx,'(a,6x,a)')'SYMM',strsym
   10 CONTINUE
c    Record 5
c                               NFOUR NPRNT NPLOT NTRNS NREF NTYPE
      WRITE(isx,'(a)')'FORD          1    1    1    0   50    1 '
c    Record set 6 not included  because NTRNS=0
c    Record set 7
c                      'FSCREEN       SINMAX    SINMIN    RMAX  (A4,6X,7F10.0)
      WRITE(isx,'(a)') 'FSCREEN     1.000000    0.0000    0.50 '
c    Record set 8  A
c FLIM  XMIN XMAX YMIN YMAX ZMIN ZMAX DX DY DZ xyz NONEG RMAX NSCA PROJ DOUB
      WRITE(isx,'(a)')
     +'FLIM        0.0  0.5  0.0  0.5  0.0  0.5 0.02 0.02 0.02ZXY'
c    Record set 8  B
c                      'FPLOT      NINT  ICZ  ICP  ICN      RINT ITIC '
      WRITE(isx,'(a)') 'FPLOT         1    0    1    2      0.20   20 '
c    Record set 8  C
c                      'PTIT       Any title
      WRITE(isx,'(a)') 'PTIT      Title of the Plot: '
      close(unit=isx)
      RETURN
      END
C*****************************************************************
      Subroutine StringSym(IM,TS,Strsym)
      dimension IM(3,3),TS(3),ino(3),lni(3)
      Character Strsym*50,xyzt(3)*15,sigx(3)*1,xlab(3)*1,auxc*15
      data xlab/'X','Y','Z'/
      do i=1,3
       auxc=' '
       lenx=1

       do j=1,3
        ino(j)=0
        IF(IM(i,j).EQ.1) sigx(j)='+'
        IF(IM(i,j).EQ.-1) sigx(j)='-'
        IF(IM(i,j).EQ.0) ino(j)=1
       end do

       do j=1,3
        if(lenx.lt.1) lenx=1
        if(ino(j).eq.0) then
         if(j.eq.1.and.sigx(j).eq.'+') then
           auxc=auxc(1:lenx)//xlab(j)
          else
           auxc=auxc(1:lenx)//sigx(j)//xlab(j)
         endif
        endif
        lenx=LenStr(auxc)
       end do

       if(abs(TS(i)).gt.0.0001) then
        write(xyzt(i),'(a,a,f6.4,a)') auxc(1:lenx),'+',TS(i),','
       else
        write(xyzt(i),'(a,a)') auxc(1:lenx),','
       endif

        lni(i)=LenStr(xyzt(i))

      end do

      Strsym=xyzt(1)(1:lni(1))//xyzt(2)(1:lni(2))//xyzt(3)(1:lni(3)-1)

      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE ATOMCOR(K,IOF)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3) !1->24 Oh, 25->36 D6h
      REAL*4 IM(3,3),TS(3),X1(3),YI(3),YR(3),AX(3),AYR(3),AYI(3)
      real*4 Ltr, UQ(NEQV,3),tras(3)
      common/Latda/Nlat,in,Ltr(4,3)
      integer sigx(2),sigy(2),sigz(2)
      logical magt
      data sigx/-1,1/,sigy/-1,1/,sigz/-1,1/
      isx=i_atm
      EPS1=0.0002
      gamma=save(k,6)
      call OpenFile(18,0,k)
      Write(isx,'(A,I3)')'TITLE  Atom coordinates of phase no:',K
      write(isx,'(a,6f11.6)')'CELL ',(PAR(K,I),I=6,11)
      write(isx,'(a,20A1)')'SPGR ',(SYMB(K,I),I=1,20)
      write(isx,'(a,i3)')'JBTV ',JBT(K)
      nvkk=iabs(nvk(k))
      if(genk(k).eq.'Y') nvkk=nvkk/2
      if(iabs(jbt(k)).eq.5) then
        nvkk=nvkk+1
        do i=1,3
         PVK(K,nvkk,i)=0.0
        end do
      endif
      write(isx,'(a,I3)')'VECK ',NVKK
      do nv=1,nvkk
       write(isx,'(a,i1,a,3f9.5)')'Vk_',nv,' ',(PVK(K,nv,I),I=1,3)
      end do
C
C  WRITE ALL ATOMS IN THE UNIT CELL (PRIMITIVE)
C
      magt=.false.

      IF(iabs(JBT(K)).eq.1.or.iabs(JBT(K)).eq.5.or.iabs(JBT(k)).eq.10)
     +    magt=.true.

      MULTG=MLTG(K)
      if(jbt(k).eq.5 .or. multg.eq.0) then
       multg=1
       IVEC(K,1)=1
        DO  J=1,3
         TR(K,1,J)=0.0
        end do
      endif

      OCC=1.0
      DO 20 i=1,natom(k)
      IPIOF=IOF+I
      if(iabs(jbt(k)).eq.10.and.iabs(jdist(k)).eq.1.and.n_t(ipiof).ne.1)
     +            goto 20
       DO J=1,3
        tras(j)=0.0
        X1(J)=XL(IPIOF,J)

        if(iabs(jbt(K)).ne.5) then
          if(x1(j).lt.0) then     !Put atoms inside the unit cell
           x1(j)=x1(j)+1.0
           tras(j)=tras(j)+1.0
          endif
          if(x1(j).ge.1)then
           x1(j)=x1(j)-1.0
           tras(j)=tras(j)-1.0
          endif
         endif

          YR(J)=XL(IPIOF,J+5)
          YI(J)=XL(IPIOF,J+8)

        UQ(1,J)=X1(J)
        END DO

        if(jbt(k).eq.-1.or.jbt(k).eq.-10) then
         call spherx(xl(ipiof,6),xl(ipiof,7),xl(ipiof,8),gamma,yr)
         call spherx(xl(ipiof,9),xl(ipiof,10),xl(ipiof,11),gamma,yi)
        endif


        if(magt) then
          pph=0.0
       IKPIO=IKV(IPIOF)
       IF(IKPIO.NE.0) THEN
        IKPIA=IABS(IKPIO)
        IF(IKPIO.LT.0.AND.GENK(K).EQ.'Y') IKPIO=NVK(K)/2+IKPIA
        IF(IKPIO.LT.0.AND.GENK(K).NE.'Y') IKPIO=1+IKPIA
       ENDIF
       iv=ikpio
          if(iv.eq.0) iv=1
          do j=1,3
           pph=pph+tras(j)*pvk(k,iv,j)
          end do
          xl(ipiof,12)=xl(ipiof,12)+pph
        endif !magt

       ITOT=1
       BISO=XL(IPIOF,4)
       IRIN=ISAP(IPIOF,1)
       IRFI=ISAP(IPIOF,2)
      IF(IRIN.EQ.0.OR.IRFI.EQ.0.or.magt) THEN
       IRIN=1
       IRFI=multg
      ENDIF
C
      ipass=0
      DO 10 IRR=irin,irfi
  30   if(irin.ne.1.and.ipass.eq.0) then
        IR=1
       else
        IR=IRR
       endif
        II=IABS(IVEC(K,IR))
        ISS=IVEC(K,IR)/II
        DO 301 J=1,3
         TS(J)=TR(K,IR,J)
        DO 301 L=1,3
  301 IM(J,L)=ISS*MOD6(II,J,L)
      CALL APSYM(IM,X1,AX,TS,1)
      do j=1,3
       tras(j)=0.0
        if(ax(j).lt.0) then
         ax(j)=ax(j)+1.0
         tras(j)=tras(j)+1.0
        endif
        if(ax(j).ge.1)then
         ax(j)=ax(j)-1.0
         tras(j)=tras(j)-1.0
        endif
      end do

      IF(IR.GT.1) THEN
      if(nlat.eq.1.or.magt) then     !Test on centered translations applied
      DO  JJ=1,ITOT                  !only for magnetic phases
       R1=ABS(UQ(JJ,1)-AX(1))
       R2=ABS(UQ(JJ,2)-AX(2))
       R3=ABS(UQ(JJ,3)-AX(3))
       IF(R1.LE.EPS1.AND.R2.LE.EPS1.AND.R3.LE.EPS1) GOTO 10
      end do
      else
      DO  JJ=1,ITOT
       R1=ABS(UQ(JJ,1)-AX(1))
       R2=ABS(UQ(JJ,2)-AX(2))
       R3=ABS(UQ(JJ,3)-AX(3))
       IF(R1.LE.EPS1.AND.R2.LE.EPS1.AND.R3.LE.EPS1) GOTO 10
      end do
      do nn=2,nlat
       do ix=1,2
       do iy=1,2
       do iz=1,2
      DO 300 JJ=1,ITOT
      R1=ABS(UQ(JJ,1)-AX(1)+sigx(ix)*Ltr(nn,1))
      R2=ABS(UQ(JJ,2)-AX(2)+sigy(iy)*Ltr(nn,2))
      R3=ABS(UQ(JJ,3)-AX(3)+sigz(iz)*Ltr(nn,3))
      IF(R1.LE.EPS1.AND.R2.LE.EPS1.AND.R3.LE.EPS1) GOTO 10
  300 CONTINUE
       end do
       end do
       end do
      end do
      endif
      ENDIF

      ITOT=ITOT+1
      DO J=1,3
       UQ(ITOT,J)=AX(J)
      END DO

      IF(magt) then
      pph=0.0
      DO J=1,3
        pph=pph+tras(j)*pvk(k,iv,j)
      END DO
      pph=xl(ipiof,12)+pph
       L=IMAGR(IPIOF)
       II=IABS(MVEC(K,L,IR))
       if(II.eq.0) II=1
       ISS=MVEC(K,L,IR)/II
       DO 303 J=1,3
       DO 303 JJ=1,3
  303 IM(J,JJ)=ISS*MOD6(II,J,JJ)
      CALL APSYM(IM,YR,AYR,TS,0)
      CALL APSYM(IM,YI,AYI,TS,0)
        pph=pph+pmag(K,L,IR)
      endif
        if(jdist(k).lt.0) then
        if(iabs(IKV(IPIOF)).le.1) then
      WRITE(ISX,51) ATEXT(IPIOF),(AX(J),J=1,3),BISO,OCC,
     + iabs(IKV(IPIOF)),(AYR(J),J=1,3),(AYI(J),J=1,3),pph
  51  FORMAT('ATOM ',A4,1X,5F9.5/'MK_P ',i3,1x,6F9.3,f9.5)
        else
      WRITE(ISX,52) iabs(IKV(IPIOF)),(AYR(J),J=1,3),(AYI(J),J=1,3),pph
  52  FORMAT('MK_P ',i3,1x,6F9.3,f9.5)
        endif
        else
      WRITE(ISX,50) ATEXT(IPIOF),NTYP(IPIOF),IMAGR(IPIOF),
     + IKV(IPIOF),(AX(J),J=1,3),BISO,OCC,(AYR(J),J=1,3),
     + (A(IPIOF,J),J=1,8),(AYI(J),J=1,3),
     + (XL(I+IOF,J),J=13,15),pph,(A(I+IOF,J),J=9,11),
     + (A(I+IOF,J),J=13,15), A(I+IOF,12)
        endif
      if(ipass.eq.0.and.irin.ne.1) then
       ipass=1
       goto 30
      endif
  10  CONTINUE
  20  CONTINUE
  50  FORMAT(
     + A4,1x,a4,I3,1X,I2,1X,5F8.5,3F8.3/16X,8F8.2/6F8.3,f8.5/7F8.2)
C
      close(unit=isx)
      RETURN
      END
C*****************************************************************
      subroutine spherx(r,phi,theta,gam,sm)
       dimension sm(3)
       EXTERNAL sind,cosd
       csi=COSD(gam)/SIND(gam)
       csp=COSD(phi)     !PHI
       scp=SIND(phi)
       cst=COSD(theta)     !THETA
       sct=SIND(theta)
       CMx=r*CSp*SCt
       CMy=r*SCp*SCt
       SM(1)=CMx-CMy*csi
       SM(2)=CMy/SIND(gam)
       SM(3)=r*CSt
      return
      end
C*****************************************************************
      SUBROUTINE APSYM(R,X,XX,T,ICOD)
      DIMENSION R(3,3),X(3),XX(3),T(3)
      DO I=1,3
      XX(I)=ICOD*T(I)
        DO J=1,3
         XX(I)=XX(I)+R(I,J)*X(J)
        END DO
      END DO
      RETURN
      END
C-----------------------------------------------------------------------
      Subroutine RMS_B(cell,celang,bet)
      include 'ful0.inc'
      dimension cell(3),celang(3),bet(6),beta(3,3),rms(3)
      real*4 L(3,3),LT(3,3),aux(3,3),u(3,3)
      EXTERNAL ACOSD
      data pi/3.14159265/
      do j=1,3
       beta(j,j)=bet(j)
      end do
       beta(1,2)=bet(4)
       beta(1,3)=bet(5)
       beta(2,3)=bet(6)
       beta(2,1)=beta(1,2)
       beta(2,1)=beta(1,2)
       beta(2,1)=beta(1,2)
       beta(3,1)=beta(1,3)
       beta(3,2)=beta(2,3)
c      CALL MATRIX(CELL,CELANG,L,aux,'ORTHOG')  !Crystal->orth Matrix
       call get_orthog(cell,celang,L)
c      CALL MATRIX(L,LT,aux,aux,'TRNSPS')       !Tranpose matrix
       call matrans(L,LT,3)
      do i=1,3
       DO j=1,3
        U(j,I)=L(I,j)/CELL(j)
        BETA(i,j)=BETA(i,j)/2.0/PI/PI
       end do
      end do
c      CALL MATRIX(L,BETA,aux,aux,'MATMUL')     !Transform beta/2pi**2 to U's
       call matmult(L,BETA,AUX,3)
c      CALL MATRIX(aux,LT,beta,aux,'MATMUL')    !Now beta is U
       call matmult(aux,LT,beta,3)
c      CALL MATRIX(beta,RMS,aux,aux,'DIAGON')   !Diagonalize U
       call mat3_diag(beta,rms,aux)
      write(i_out,'(/a)')
     + '    U-Eigen Value (A**2) ----      Eigen vector(Orth. syst.)'
      DO I =1,3
       rms(i)=rms(i)*1.0e-04
       write(i_out,'((5x,F10.5,a,3(1x,F10.5)))')
     +      RMS(I),'          ----',(AUX(j,I),j=1,3)
      end do
      BISO=0.0
      ineg=0
      DO I=1,3
      BISO=BISO+RMS(I)
       IF(RMS(I).lt.0.0) then
        write(i_out,'(/a)')'   -> Matrix U non-positive definite! '
        ineg=1
       else
        RMS(I)=SQRT(RMS(I))
       endif
      end do
      BISO=BISO/3.0*8.0*PI*PI
      write(i_out,'(/a,f8.4/)')
     +'    Isotropic temperature factor B(A**2): ',biso
      if(ineg.eq.0) then
c      CALL MATRIX(U,AUX,LT,L,'MATMUL')  !now LT contains director cosines
       call matmult(u,aux,LT,3)
      DO I=1,3
          DO J=1,3
           IF(ABS(LT(I,J)).GT.1.0) LT(I,J)=sign(1.0,Lt(i,j))
           LT(I,J)=ACOSD(LT(I,J))
          end do
      end do
      WRITE(i_out,'(a)')
     + '     R.M.S. in ANGSTROMS ------       Angles with A, B, C'
      do i=1,3
        WRITE(i_out,'((5x,F10.5,a,3(1x,F10.3)))')
     +                RMS(I),'          ----',(LT(J,I),J=1,3)
      end do
      WRITE(i_out,'(a)')' '
      endif
      return
      END
