C     Last change:  JRC   9 Mar 97   12:19 pm
C-----------------------------------------------------------------------
      SUBROUTINE READINT
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON    /FORMATO/INSTR,NUMOR,TSAMP
      character    aLine*132,FMTformat*132,FMTfields*80
      Integer*4    nCarL,iErr
      CHARACTER DATAID*56
      CHARACTER DATE1*5
      CHARACTER DATE*80,TXT1*80,TXT2*80,TXT3*80
      DIMENSION VOLT(5)
      CHARACTER JDATE*18,NOEXP*10,P1A*72

      ICONSTEP=1
      cnorm=1.0
      eps1=1.0e-05
c
c Opening files .SYM and RPA
c
      call Openfile(5,0,1)
C
      WRITE(i_out,1)
      DO 1000 I=1,IDSZ
 1000 IWW(I)=1
      IF (INSTR.EQ.0) THEN
C
C FIRST USUAL READING
C
        line_da=0
  99    line_da=line_da+1
        if(line_da.gt.7) goto 543
         READ(i_dat,*,END=99998,err=99)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         if(npts.lt.4) then
          if(line_da.lt.7) goto 99
          goto 543
         endif
         IF (NPTS.GT.IDSZ) THEN
            WRITE(i_out,2)IDSZ,NPTS
            call clear_string(fmtfields)
            WRITE(fmtfields,2)IDSZ,NPTS
            call mess(fmtfields)
            CALL STOP_COND(' Too many points ',1)
         END IF
         READ(i_dat,*,END=99998,err=543)(Y(I),I=1,NPTS)
         DO     I=1,NPTS
           VAR(I) = Y(I)
           TXV(I)= THMIN+(I-1)*step
         END DO
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.1) THEN
C
C DATA FROM D1A,D2B(ILL) OLD FORMAT
C
         READ(i_dat,*,END=99998,err=543)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         READ(i_dat,3,END=99998,err=543)(IWW(I),Y(I),I=1,NPTS)
         DO 4 I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).EQ.0) IWW(I) = 1
           VAR(I) = Y(I)/FLOAT(IWW(I))
           TXV(I)= THMIN+(I-1)*step
    4    CONTINUE
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.2) THEN
C
C DATA FROM D1B(ILL) OLD FORMAT
C
         WRITE(i_out,'(a)') '  -> Parameters from *.dat file:'
         READ(i_dat,5,END=99998,err=543)DATE
         WRITE(i_out,6)DATE
    6 FORMAT(/1X,'=> Date of experiment: ',A80)
         READ(i_dat,5,END=99998,err=543)TXT1
         READ(i_dat,*,END=99998,err=543)IO,NUMOR
         TSAMP = FLOAT(NUMOR)
         INUM = 1
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
         WRITE(i_sum,'(A,I6,F8.2)')' -> Numor & Tsample: ',NUMOR,TSAMP
         READ(i_dat,5,END=99998,err=543)TXT2
         READ(i_dat,5,END=99998,err=543)TXT3
         WRITE(i_out,10)NUMOR,TXT1,TXT2,TXT3,IO
   10 FORMAT(1X,'=> Numor: ',I7,1X,'Title of experiment: ',A80/
     +         '           ',a80/'         ',a80, 'IO: ',i5)
         J = 0
         READ(i_dat,'(f7.3,10f6.0)',END=99998,err=543)
     +         A1,(Y(J+NO),NO=1,10)
         J = J+10
         DO 9 I=2,40
          READ(i_dat,'(f7.3,10f6.0)',END=99998,err=543)(Y(J+NO),NO=1,10)
          J = J+10
    9    CONTINUE
        Y(1) = Y(2)
         Y(400) = Y(399)
         THMIN = 2.0*A1
         STEP = 0.2
         NPTS = 400
         THMAX = THMIN+399*STEP
         DO I=1,NPTS
           VAR(I) = Y(I)
           TXV(I)= THMIN+(I-1)*step
         END DO
      ELSE IF (INSTR.EQ.3) THEN
C
C DATA FROM D1B,D20 NEW FORMAT
C
   11 FORMAT(I5)
         WRITE(i_out,'(a)')   '  -> Parameters from *.dat file:'
         READ(i_dat,11,END=99998,err=543)NSET
         WRITE(i_out,'(a,i5)')'     Nset:',NSET
         READ(i_dat,12,END=99998,err=543)JDATE,NOEXP,P1A
         WRITE(i_out,'(a18,1x,a10,1x,a72)')JDATE,NOEXP,P1A
         READ(i_dat,13,END=99998,err=543)NSET1,NUMOR,NSUMAD
         WRITE(i_out,'(3i8)')NSET1,NUMOR,NSUMAD
         READ(i_dat,14,END=99998,err=543)
     *        XM,TI,X0,OME,CHI,PHI,TR1,TR2,STEP,TSET,TCONS,TSAMP
         WRITE(i_out,14)
     +        XM,TI,X0,OME,CHI,PHI,TR1,TR2,STEP,TSET,TCONS,TSAMP
         THMIN = X0
         READ(i_dat,15,err=543)NPTS,(VOLT(NV),NV=1,5),NUMC1,NUMC2
         WRITE(i_out,15)NPTS,(VOLT(NV),NV=1,5),NUMC1,NUMC2
   15 FORMAT(I4,1X,5(F9.3,1X),29X,I6,3X,I6)
        WRITE(i_out,'(A,I6,F8.4)')' -> Numor & Tsample: ',NUMOR,TSAMP
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2,7F8.3,5F8.4)')'DATT ',NUMOR,
     +  NSUMAD,TSAMP,TSET,TCONS,OME,CHI,PHI,TR1,TR2,(VOLT(NV),NV=1,5)
         WRITE(i_sum,'(A,I6,F8.2)')' => Numor & Tsample: ',NUMOR,TSAMP
         J = 0
         NPUNT = NINT(FLOAT(NPTS)/10.)
         WRITE(i_out,17)NPUNT
         THMAX = THMIN+(NPTS-1)*STEP
         DO 18 I=1,NPUNT
           READ(i_dat,19,END=99998,err=543)(IWW(J+NO),Y(J+NO),NO=1,10)
           J = J+10
   18    CONTINUE
         READ(i_dat,20,END=99998,err=543)INUM
         DO I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).LE.0) IWW(I) = 1
           VAR(I) = Y(I)/FLOAT(IWW(I))
           TXV(I)= THMIN+(I-1)*step
         END DO
      ELSE IF (iabs(INSTR).EQ.4) THEN
C
C DATA FROM N.L.S (BROOKHAVEN) SYNCHROTRON RADIATION
C
         if(instr.eq.4) then
         READ(i_dat,*,END=99998,err=543)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         NLINES = NPTS/10+1
         J = 0
         DO I=1,NLINES
           READ(i_dat,23,END=99998,err=543)(Y(J+NO),NO=1,10)
           READ(i_dat,24,END=99998,err=543)(VAR(J+NO),NO=1,10)
           J = J+10
         END DO
         VAR(1) = VAR(1)**2
         TXV(1)=THMIN
         DO I=2,NPTS
            IF (Y(I).EQ.0) Y(I) = Y(I-1)
            IF (VAR(I).LE.0.00001) VAR(I) = 1.0
            VAR(I) = VAR(I)**2
            TXV(I)= THMIN+(I-1)*step
         END DO
c
C READ DATA FROM SYNCHROTRON SOURCE AND CORRECT DATA FOR DEAD TIME
C
         else
         READ(i_dat,26,END=99998,err=543)DATE1,DATAID
         WRITE(i_out,27)DATAID
         READ(i_dat,28,END=99998,err=543)NRANGE,CHMBRI,TAUK
         NPTS = 0
         DO 29 J=1,NRANGE
           READ(i_dat,30,END=99998,err=543)ANGMIN,STEP,ANGMAX,STPTIM,
     +                                 OFSTI0,OFSTI1
           IPTS = (ANGMAX-ANGMIN)/STEP+1.5
           IF (J.EQ.1) THMIN = ANGMIN
           IF (J.EQ.NRANGE) THMAX = ANGMAX
           IF (J.GT.1) THEN
              READ(i_dat,31,END=99998,err=543)
              IPTS = IPTS-1
           END IF
           IF (NPTS+IPTS.GT.IDSZ) THEN
              WRITE(i_out,2)IDSZ,NPTS+IPTS
            call clear_string(fmtfields)
            WRITE(fmtfields,2)IDSZ,NPTS+IPTS
            call mess(fmtfields)
              CALL STOP_COND(' Too many points ',1)
           END IF
           IF (DATE1.EQ.'OCT85') THEN
       READ(i_dat,31,END=99998,err=543)(Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
       ELSE IF (DATE1.EQ.'FEB86') THEN
       READ(i_dat,33,END=99998,err=543)(Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
       ELSE IF (DATE1.EQ.'AUG86') THEN
       READ(i_dat,34,END=99998,err=543)(VAR(I+NPTS),Y(I+NPTS),I=1,IPTS)
           ELSE
              WRITE(i_out,35)
           END IF
           TAUK = 2.4621E-6
           DO 36 I=NPTS+1,NPTS+IPTS
             Y(I) = Y(I)/STPTIM
             FLEET1 = VAR(I)-OFSTI0
             FLEET2 = FLEET1/CHMBRI
             FLEET2 = (FLEET2*STPTIM*(1-TAUK*Y(I)))**2
             VAR(I) = (STPTIM*Y(I))/FLEET2
             Y(I) = (Y(I)/(1-TAUK*Y(I))-OFSTI1)*CHMBRI/FLEET1
             IF (ABS(Y(I)).LT.0.01) Y(I) = 1
   36      CONTINUE
           NPTS = NPTS+IPTS
   29    CONTINUE
         endif
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.5) THEN
C
C DATA FROM GENERAL FORMAT OF TWO AXIS INSTRUMENTS WITH FIXED STEP IN TWOTHETA
C
      WRITE(i_out,'(A/)') ' -> Heading of input data:'
      READ(i_dat,'(A)',err=543)TXT1                  !1
      WRITE(i_out,'(A,A)')'   -> ',TXT1
      READ(i_dat,'(A)',err=543)TXT2                  !2
      WRITE(i_out,'(A,A)')'   -> ',TXT2
      READ(i_dat,'(A)',err=543)TXT3                  !3
      WRITE(i_out,'(A,A)')'   -> ',TXT3
      READ(i_dat,'(I6,1X,2F10.3,i5,2f10.1)',err=543)
     +  NPTS,TSAMP,Treg,ivari,rmon1,rmon2                         !4
      WRITE(i_out,'(a,I5,a,2F8.2)')'   -> NPTS: ',NPTS,
     + ' Temperature (Sample & Regul): ',TSAMP,Treg
      READ(i_dat,'(3F10.0)',err=543)THMIN,STEP,THMAX              !5
      WRITE(i_out,'(a,3f10.4,2f10.1)')'   -> THMIN,STEP,THMAX,MONITs: ',
     +                       THMIN,STEP,THMAX,rmon1,rmon2
      READ(i_dat,'(10F8.1)',err=543)(Y(I),I=1,NPTS)
      if(ivari.ne.0) then          !IVARI
        WRITE(i_out,'(a/)')
     +   '   -> Standard deviations of Yi read from file '
         READ(i_dat,'(10F8.2)',err=543)(VAR(I),I=1,NPTS)
         do i=1,npts
          if(y(i).lt.0.0001) y(i)=0.0001
          var(i)=var(i)*var(i)
          if(var(i).lt.0.000001) var(i)=1.0
          TXV(I)= THMIN+(I-1)*step
         end do
      else                         !IVARI
        if(rmon1.gt.1.0.and.rmon2.gt.1.0) then
         cnorm=rmon1/rmon2
          cnorm=cnorm*cnorm
         WRITE(i_out,'(a/)')
     +'   -> Standard deviations of Yi assumed SQRT(Yi*Cnorm/Monitor) '
        else
         cnorm=1.0
         WRITE(i_out,'(a/)')
     +       '   -> Standard deviations of Yi assumed SQRT(Yi) '
        endif
         do i=1,npts
          var(i)=y(i)*cnorm
          TXV(I)= THMIN+(I-1)*step
         end do
      endif                        !IVARI

        IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.6) THEN
C
C DATA FROM D1A,D2B  (FILES *.SUM, RENAMED *.DAT, AS PREPARED BY D1ASUM
C                     OR D2BSUM PROGRAMS)
C
      WRITE(i_out,'(A/)') ' -> Heading of input data:'
        READ(i_dat,'(A72)',err=543) P1A
      WRITE(i_out,'(A,A/)')    '   ->   Title: ',P1A
        READ(i_dat,'(16x,F8.3)',err=543)STEP
        WRITE(i_out,'(a,f6.3)')'   ->    Step: ',STEP
      READ(i_dat,'(F8.3)',err=543)THMIN
        WRITE(i_out,'(a,F8.3)')'   ->   Thmin: ',THMIN
      READ(i_dat,'(2F8.0)',err=543) RMONI,RMONIOLD
      IF(RMONIOLD.LT.1.) then
       cnorm=1.00
       RMONIOLD=RMONI
      else
       CNORM=RMONI/RMONIOLD
      endif
        WRITE(i_out,'(a,2F8.0)')'   -> Monitors: ', RMONI,RMONIOLD
         NPUNT = NINT(18./STEP)
         J=0
      DO I=1,NPUNT
           READ(i_dat,3,err=543)(IWW(J+NO),Y(J+NO),NO=1,10)
        IF(abs(Y(J+1)+1000.).lt.1.e-03) GOTO 999
           J = J+10
      END DO
999      J=J-10
      NPTS=J
         THMAX = THMIN+(NPTS-1)*STEP
      DO   I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).EQ.0) IWW(I) = 1
           VAR(I) = CNORM*Y(I)/FLOAT(IWW(I))
           TXV(I)= THMIN+(I-1)*step
      END DO
         IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.7) THEN
C
C DATA FROM D4,D20L
C
      READ(i_dat,'(I5,1X,F5.0,1X,A72)',err=543)NPTS,TSAMP,P1A
      READ(i_dat,'(5(F7.2,1X,F8.1,1X,F5.1))',err=543)
     +                             (TXV(I),Y(I),VAR(I),I=1,NPTS)
      ICONSTEP=0
        STEP=TXV(2)-TXV(1)
      THMIN=TXV(1)
        THMAX=TXV(NPTS)
      DO I=1,NPTS
         VAR(I)=0.5*VAR(I)*VAR(I)
      END DO
        IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP
      ELSE IF (INSTR.EQ.8) THEN
C
C DATA FROM DMC
C
      WRITE(i_out,'(A/)') ' -> Heading of input data:'
      READ(i_dat,'(A)',err=543)TXT1
      READ(i_dat,'(A)',err=543)TXT2
      WRITE(i_out,'(A,A)')'   -> ',TXT1
      WRITE(i_out,'(A,A/)')'   -> ',TXT2
      READ(i_dat,*,err=543) THMIN,STEP,THMAX
      NPTS = (THMAX - THMIN)/STEP + 1.005
      READ(i_dat,'(10F8.0)',END=20734,err=543)(Y(I),I=1,NPTS)
      READ(i_dat,'(10F8.0)',END=20734,err=543)(Var(I),I=1,NPTS)
20734 CONTINUE
      DO I=1,NPTS
       IWW(I) = 1
       VAR(I) = Var(I)*Var(i)
       TXV(I)= THMIN+(I-1)*step
      END DO
        IF (JCIL.GT.0)
     +   WRITE(i_rpa,'(A,I8,I4,F12.2)')'DATT ',NUMOR,INUM,TSAMP

      ELSE IF (INSTR.EQ.9) THEN
         Call Socabim
         do i=1,npts
          TXV(I)= THMIN+(I-1)*step
         end do

      ELSE IF (INSTR.EQ.10) THEN   !T.O.F. corrected data file from ISIS
        ntt=0                      !Or X,Y sigma data
        fac_x=1.0
        fac_y=1.0
        interpol=0
        read(i_dat,'(a)') Txt1
        line_da=1
        ICONSTEP=0
       if(txt1(1:6).ne.'XYDATA') then
        WRITE(i_out,'(A/a)')
     +  ' -> No recognizable heading in input data file X,Y,sigma',
     +  '    First 6 lines are considered as COMMENTS '
        WRITE(i_out,'(A,a)') ' -> COMMENT: ',txt1
         do i=1,5
          read(i_dat,'(a)') Txt1
          WRITE(i_out,'(A,a)') ' -> COMMENT: ',txt1
         end do
       else
        WRITE(i_out,'(A/)') ' => Heading of input data file X,Y,sigma'
         do i=1,5
         read(i_dat,'(a)') Txt1
         WRITE(i_out,'(A,A)')' -> ',TXT1
         line_da=line_da+1
         if(txt1(1:5).eq.'INTER') then     !Interpolation possible!
          backspace i_dat
          line_da=line_da-1
          FMTfields = '5ffif'
          Call FindFMT(i_dat,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 37
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) date1,fac_x,fac_y,interpol,stepin
          if(fac_x.le.0.0) fac_x=1.0
          if(fac_y.le.0.0) fac_y=1.0
          WRITE(i_out,'(A,f12.4)')
     +   ' -> Input X-values multiplied internally by ',fac_x
          WRITE(i_out,'(A,f12.4)')
     +   ' -> Input Y & Sigma-values multiplied internally by ',fac_y
          endif
         if(txt1(1:4).eq.'TEMP') then
           read(txt1(5:80),*) tsamp
         endif
          end do
       endif

       if(interpol.eq.0) then
        ICONSTEP=0
       else
        WRITE(i_out,'(A,f9.5)')
     +   ' -> Internal interpolation for constant STEP =',stepin
        ICONSTEP=1
       endif

        FMTfields = 'fff'
         sumavar=0.0
        do I=1,idsz
        line_da=line_da+1
         Call FindFMT(i_dat,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 37
         if (iErr.ne.0)  GoTo 99995
         READ(aLine,FMTformat)txv(i),Y(i),var(i)
         if(abs(txv(i)).lt.eps1.and.abs(y(i)).lt.eps1.and.
     +                  abs(var(i)).lt.eps1) goto 37
         txv(i)=txv(i)*fac_x
         y(i)=y(i)*fac_y
         var(i)=var(i)*fac_y
         var(i)=var(i)*var(i)
         sumavar=sumavar+var(i)
         if(i.gt.1) then
          step=step+txv(i)-txv(i-1)
          ntt=ntt+1
         endif
        end do

  37    npts=ntt+1
        thmin=txv(1)
        thmax=txv(npts)
        if(sumavar.lt.eps1) then
         do i=1,npts
          var(i)=y(i)
         end do
        endif
c------------------------------------------------------
        if(interpol.eq.0) then      !If interpol
         step=step/float(ntt)
c------------------------------------------------------
        else                        !else interpol
c------------------------------------------------------

         ntt=ntt+1
         step=stepin
         npts=(txv(ntt)-txv(1))/step+1.05
c
c  First interpolate the raw intensities
c
         yp1=9.9e+32
         ypn=9.9e+32
        CALL SPLINE(txv,y,ntt,YP1,YPN,bk)
        DO I=1,NPTS
          XT=txv(1)+(I-1)*STEP
          CALL SPLINT(txv,y,bk,ntt,XT,ycor)
          yc(I)=amax1(1.0,ycor)
        End Do
         do i=1,npts
          y(i)=yc(i)
          yc(i)=0.0
          bk(i)=0.0
         end do
c
c  Second interpolate the variances
c
        CALL SPLINE(txv,var,ntt,YP1,YPN,bk)
        DO I=1,NPTS
          XT=txv(1)+(I-1)*STEP
          CALL SPLINT(txv,var,bk,ntt,XT,ycor)
          yc(I)=amax1(1.,ycor)
        End Do
         do i=1,npts
          var(i)=yc(i)
          yc(i)=0.0
          bk(i)=0.0
         end do
         thmax=thmin+step*(npts-1)

c------------------------------------------------------
        endif                       !End If interpol
c------------------------------------------------------


      ELSE IF (INSTR.EQ.11) THEN   !Variable time X-ray data collection

         WRITE(i_out,'(A/)') ' -> Heading of input data:'
         READ(i_dat,'(A)',err=543)TXT1                  !1
         WRITE(i_out,'(A,A)')'   -> ',TXT1
         READ(i_dat,'(A)',err=543)TXT2                  !2
         WRITE(i_out,'(A,A)')'   -> ',TXT2
         READ(i_dat,'(A)',err=543)TXT3                  !3
         WRITE(i_out,'(A,A)')'   -> ',TXT3
         READ(i_dat,'(A)',err=543)TXT3                  !4
         WRITE(i_out,'(A,A)')'   -> ',TXT3
         READ(i_dat,*,err=543)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         WRITE(i_out,'(a,3f10.4,i8)')
     +   '   -> THMIN,STEP,THMAX, NPTS: ',THMIN,STEP,THMAX,NPTS
         READ(i_dat,'(5(F6.0,F10.0))',err=543)(BK(I),Y(I),I=1,NPTS)
c
c   Normalize data to constant time
c
        cnorm=0.0
         do i=1,npts
          if(bk(i).lt.1.0e-06)CALL STOP_COND(' Zero time in *.DAT ',1)
          cnorm=cnorm+bk(i)
         end do
          cnorm=cnorm/float(npts)
         do i=1,npts
          y(i)=y(i)*cnorm/bk(i)
          var(i)=y(i)
          bk(i)=0.0
         end do
         WRITE(i_out,'(a,a,f10.4)')' => Variable time data collection,',
     +    ' Normalizing Time: ',cnorm

      ELSE
              CALL STOP_COND(' Invalid INSTR parameter ',1)
      END IF
C
C
    1 FORMAT(/1X,'=> Reading Intensity data  =>>'/)
    2 FORMAT(1X, '=> Program can handle',I5,'points',/,
     *       22X,I5,' points were input')
    3 FORMAT(10(I2,F6.0))
    5 FORMAT(A80)
   12 FORMAT(1X,A,2X,A,2X,A)
   13 FORMAT(I3,1X,I6,1X,I4)
   14 FORMAT(F13.0,F9.0,1X,10(F8.3,1X))
   16 FORMAT(1X,'=> Numor: ',I6,' Nsum: ',I4,' Temp.Sampl. ',F12.3)
   17 FORMAT(' => Number of data lines: ',I5/)
   19 FORMAT(10(I2,F8.0))
   20 FORMAT(I10)
   23 FORMAT(10F8.0)
   24 FORMAT(10F8.1)
   26 FORMAT(A5,A56)
   27 FORMAT(A56)
   28 FORMAT(BZ,I8,F8.0,G10.0)
   30 FORMAT(BZ,6F8.0)
   31 FORMAT(BZ,24X,F7.0,1X,F7.0)
   33 FORMAT(BZ,24X,F7.0,1X,F7.0)
   34 FORMAT(BZ,51X,F10.0,1X,F10.0)
   35 FORMAT(5X,'WHEN WAS THIS DATA TAKEN. OCT85,FEB86 OR AUG86')
      CLOSE(UNIT=i_dat)
c
c Modify the size for STEP,NPTS and associated arrays Y,IWW and VAR, if
c ISTEP is greater than 1.
c
      if(istep.gt.1) then
       npts=NPTS/ISTEP
       step=step*ISTEP
       THMAX = THMIN+(NPTS-1)*STEP
       j=1
       do i=2,NPTS
         j=j+ISTEP
           Y(I)=Y(J)
           VAR(I)=VAR(J)
           IWW(I)=IWW(J)
           TXV(I)=TXV(J)
       end do
      endif
      TXV(NPTS+1)=TXV(NPTS)+(TXV(NPTS)-TXV(NPTS-1))
      RETURN
99998 CALL STOP_COND(' End of file *.DAT ',1)
  543 CALL STOP_COND('  Error on Intensity file, check your INSTR parame
     +ter! ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      call message(
     +' => Please check your *.DAT file at line: ',Line_da,0.0,1)
      CALL STOP_COND(' Format error ',1)
      END
C****************************************************************
      Subroutine Socabim
c     Call Stop_cond(' Sorry, input from Eva2 software not available',1)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      COMMON/FORMATO/INSTR,NUMOR,TSAMP
C
C----- Definitions of Socabim parameters
      Character*1  iden,first(8),ctst,rota,smode,head3(3)
      Character*2  anode
      Character*3  test,head1(31),oscil
      Character*8  head2(4),stest,driv,datfil
      Character    text*128,datm*20,sid*80,sidp*80,scmod*15
      Real rtim,wav1,wav2,wav3,wavr,stime,step,start,thmin,thmax,omega
      Real chi,phi,tr1,tr2,div,hvolt,mamp,hv,gain,lld,uld,ospd,osampl
     +    ,Tsamp
      Integer      i,jj,k,l,il,idat,jout,npts,chan
C
      Data first/'_','+','-','.',';','*','/',' '/
      Data head1/'FIL','SAM','+SA','DAT','RUN','WL1','WL2','WL3',
     1'WLR','ANO','DRI','STE','STA','2TH','THE','KHI','PHI','X= ',
     2'Y= ','KV=','MA=','CHA','HV=','GAI','LLD','ULD','ROT','COU',
     3'DIV','OSC','TEM'/
      Data head2/'STEPTIME','STEPSIZE','STEPMODE','STEPCOUN'/
      Data head3/'=','S','A'/
C
C     Read Socabim files in "Universal" format (from XCH)
C____________________________________________________________
C
      idat=i_dat
      jout=i_out
      isum=i_sum
 1000 read(idat,'(a,a)',err=800)iden,text
C----- Transform to upper case
      call UpperCase(text)
C
C***** Decode content of line (keyword, comments, counts or blank)
C
      do i=1,8
        if(iden.eq.first(i))then
          goto(100,120,120,120,140,140,140,160),i
        endif
      end do
          goto 1000
C
C***** read keyword
C
  100 test=text(1:3)
      do i=1,31
        if(test.eq.head1(i))then
          goto(201,202,203,204,205,206,207,208,209,210,
     1    211,212,213,214,215,216,217,218,219,220,221,
     2    222,223,224,225,226,227,228,229,230,231),i
        endif
       end do
C----- read file version (not implemented yet in XCH)
  201 goto 1000
C----- read sample identification and extension. Trim to 80 characters only
  202 do l=9,120
        ctst=text(l:l)
         if(ctst.eq.'''')then
           il=l-1
           goto 1202
         endif
      end do
 1202 sid=text(9:il)
      goto 1000
  203 sidp=text(10:90)
      goto 1000
C----- read date of measurement
  204 datm=text(15:34)
      goto 1000
C----- read runtime
  205 read(text(9:16),'(F8.0)')rtim
      goto 1000
C----- read wavelengths and wavelength ratio
  206 read(text(5:12),'(F8.0)')wav1
      goto 1000
  207 read(text(5:12),'(F8.0)')wav2
      goto 1000
  208 read(text(5:12),'(F8.0)')wav3
      goto 1000
  209 read(text(9:16),'(F8.0)')wavr
C----- read anode
  210 anode=text(7:8)
      goto 1000
C----- read drive coupling
  211 do l=8,15
        ctst=text(l:l)
         if(ctst.eq.'''')then
           il=l-1
           goto 1211
         endif
      end do
 1211 driv=text(8:il)
      goto 1000
C----- read step parameters
  212 stest=text(1:8)
      do i=1,4
        if(stest.eq.head2(i))then
          goto(301,302,303,304),i
        endif
      end do
      goto 1000
  301 read(text(10:14),'(F5.0)')stime
      goto 1000
  302 read(text(10:17),'(F8.0)')step
      goto 1000
  303 smode=text(10:10)
      scmod='step scan      '
      if(smode.eq.'C'.or.smode.eq.'c')scmod='continuous scan'
      goto 1000
  304 read(text(11:15),'(I5)')npts
      goto 1000
C----- read step scan range
  213 read(text(7:14),'(F8.0)')start
      goto 1000
C----- read starting angles
  214 read(text(8:15),'(F8.0)') thmin
      goto 1000
  215 read(text(7:14),'(F8.0)') omega
      goto 1000
  216 read(text(5:12),'(F8.0)') chi
      goto 1000
  217 read(text(5:12),'(F8.0)') phi
      goto 1000
  218 read(text(3:10),'(F8.0)') tr1
      goto 1000
  219 read(text(3:10),'(F8.0)') tr2
      goto 1000
C----- read generator settings
  220 read(text(4:6),'(F3.0)')hvolt
      goto 1000
  221 read(text(4:6),'(F3.0)')mamp
      goto 1000
  222 read(text(9:9),'(I1)')chan
      goto 1000
  223 read(text(4:7),'(F4.0)')hv
      goto 1000
  224 read(text(6:8),'(F3.0)')gain
      goto 1000
  225 read(text(5:9),'(F5.0)')lld
      goto 1000
  226 read(text(5:9),'(F5.0)')uld
      goto 1000
C----- read sample holder settings
  227 rota=text(10:10)
      goto 1000
  229 read(text(12:14),'(F3.0)')div
      goto 1000
  230 ctst=text(12:12)
      do i=1,3
        if(ctst.eq.head3(i))then
          goto(401,402,403),i
        endif
      end do
      goto 1000
  401 oscil=text(13:15)
      goto 1000
  402 read(text(10:14),'(F5.0)')ospd
      goto 1000
  403 read(text(10:14),'(F5.0)')osampl
      goto 1000
  231 read(text(13:15),'(F3.0)')tsamp
      goto 1000
C
C***** read counts
C
  228 if(text(1:6).eq.'COUNTS')then
      thmax=thmin+(npts-1)*step
        read(idat,'(8f8.0)',end=800,err=800)(y(k),k=1,npts)
        goto 800
      endif
  120 goto 1000
C
C***** read comments and skip ranges > 1 if any
  140 if(text(2:6).eq.'RANGE')then
        if(text(9:9).ne.'1')goto 800
      else
C     read name of original file with extension .RAW
            do l=2,20
          ctst=text(l:l)
                  if(ctst.eq.'.')then
                    il=l-1
                    goto 1140
                  endif
        end do
 1140   datfil=text(2:il)
      endif
      goto 1000
C
C***** skip blank line
  160 go to 1000
C
C***** Write information to output files
C
  800 write(jout,2000)datm,datfil,sid,rtim,npts,step,driv,scmod,stime,
     +  rota,thmin,omega,chi,phi,tr1,tr2,hvolt,mamp,hv,gain,lld,uld,
     +  anode,wav1,wav2,wav3,wavr
      write(isum,2000)datm,datfil,sid,rtim,npts,step,driv,scmod,stime,
     +  rota,thmin,omega,chi,phi,tr1,tr2,hvolt,mamp,hv,gain,lld,uld,
     +  anode,wav1,wav2,wav3,wavr
 2000 format(1x,'=> Experimental conditions:'/
     +4x,'Date of experiment: ',a20/4x,'Data from file:  ',a8/
     +4x,'Data identifier: ',a80/
     +4x,'Run time: ',f8.1,' for ',i5,' points   Step size = ',f6.3/
     +4x,'Scan mode: ',a8,'/',a15,' Counting time:',f5.1,
     +' secs/step  Sample rotation: ',a1/
     +4x,'Angles: 2-theta= ', f8.3,2x,'omega= ',f8.3,2x,'chi= ',f8.3,2x,
     +'phi= ',f8.3/  16x,'tr1= ',f8.3,4x,'tr2= ',f8.3/
     +4x,'Generator settings:'/
     +8x,'KV= ',f4.0,' kV MA= ',f4.0,' mA  HV= ',f4.0,
     +'  Gain= ',f4.0,'  LLD= ',f5.3,' V  ULD= ',f5.3,' V'/
     +4x,'Wavelengths:'/8x,'Anode=',a2,'  Wav1= ',f8.5,'  Wav2= ',f8.5,
     +'  Wav3= ',f8.5,  '  WaveRatio= ',f8.5/)
C         write(jout,2010)(y(i),i=1,10)
C2010 format(2x,'Intensities:'/10f8.0)
        do jj=1,npts
          if (y(jj).le.0.00001) y(jj) = 1.0
          iww(jj) = 1
          var(jj) = y(jj)
        end do
C
C***** end of data input in Socabim format
c
c The following line IS included for avoiding warning messages
c in some compilers
c
        if(SIDP.eq.OSCIL.and. NINT(START*DIV*OSPD*OSAMPL).EQ.CHAN)
     +   call mess(' =')
c
      return
      end
c------------------------------------
      Subroutine Zbelong(x,ich)
      real x
      integer ich,ix
      ix=nint(x)
      if(abs(x-float(ix)).lt.0.0001) ich=1
      return
      end
c------------------------------------
c------------------------------------
      Logical function belong(x,x1,x2)
      real x,x1,x2
      belong= x.ge.x1.and.x.le.x2
      return
      end
c------------------------------------
      SUBROUTINE DISTANC(IIP)
c
c  Subroutine to calculate distances in phase IIP
c
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      if(.NOT.(IABS(JBT(IIP)).EQ.0.OR.IABS(JBT(IIP)).EQ.5)) RETURN
      RETURN
      END
c---------------------------------------------------------------------
c  Subroutine SUMMARIZE performs an analysis of the refinement. This
c  part of the program should be developed as far as new relevant
c  indicators of the quality of the refinement are discovered.
c---------------------------------------------------------------------
      SUBROUTINE SUMMARIZE(icz,VOLUM,SBRAG,RBRAG,RF,t2o)
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      DIMENSION VOLUM(NPHT),INTDP(NPHT),NPRFP(NPHT),RBRAG(NPHT)
      DIMENSION RF(NPHT),nreph(NPHT),refeff(NPHT,3),t2o(NPHT)
      DIMENSION ibad(MSZ),itpar(MSZ),niap(MSZ),sharp(npht,2),SBRAG(NPHT)
c
c nreph(NPHT): Number of reflections of each phase in the allowed area
c refeff(NPHT,3): Effective number of reflections at levels p=1,0.5 and 0.25
c INTDP(NPHT): Number of refined Intensity-dependent parameters
c NPRFP(NPHT): Number of refined profile parameters
c NGLB: Number of refined global parameters
c Itpar(msz): Type of parameter 1:global,2:profile,3: propag. vector, 4:Intdp
c ibad(msz): Parameter appearing in more than one type
c niap(msz): Number of times that the parameter appears in the list
c
      Logical nobref,belong
      COMMON/G3/COND,IORD1,IORD2,TH,NUM,NUM1
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEV,YINV,DW,QQ1,QQ2,QQ3,SCOR
      COMMON/G22/ES1,ES2,ES3,ED1,ED2,ER1,ER2,ER3,EDEVINC,EYINV,
     +           EDW,EQQ1,EQQ2,EQQ3
      Common/Rfactor/freed,freed1,chi2,cchi2
      integer genpoi
      external genpoi,sind,cosd
C
c    S1= Sum(abs(Yiobs-Ycalc)), S2= Sum((Yiobs-Ycalc)**2/vari)
c    S3= Sum(Ycalc), D1=Sum(Yobs), QQ1=Sum(Ynet), D2=Sum(Yobs**2/vari)
c    QQ2=Sum(Ynet**2/vari)
c     R1=100.*S1/QQ1 = Rpattern (Conventional)
c     R2=100.*S1/D1  = Rpattern (Young)
c     R3=100.*SQRT(S2/D2) = Rw-pattern (Young)
c     QQ3=100.*SQRT(S2/QQ2) = Rw-pattern (Conventional)
c
      nobref=.not.((NBCKGD.EQ.0).or.(NBCKGD.EQ.1))
c
c  Calculate the relative contribution of each phase to the total integrated
c  intensity of Bragg reflections
c
      rtotal=0.0
      do k=1,nphase
       rtotal=t2o(k)+rtotal
       sharp(k,1)=100.0
      end do
      rbragt=0.0
      rfav=0.0
      do k=1,nphase
       t2o(k)=t2o(k)/rtotal
      rbragt=rbragt+rbrag(k)*t2o(k)
      rfav=rfav+RF(k)*t2o(k)
      end do
c
c  Calculate the EXPECTED Rp and cRp by a simulation method
c  Calculation of Sum(yiob-ycal) for four regions of the total pattern
c  in the same loop
c
      call Init_ran
      Rp=R2
      cRp=R1
      ss1=0.0
      sumyy1=0.0
      sumyy2=0.0
      sumyy3=0.0
      sumyy4=0.0
      sumyy=0.0
      iquar=npts/4
      DO 10 I=1,NPTS
      IF((nobref.AND.IWW(I).EQ.0).OR.IWW(I).EQ.IRS )GOTO 10
      IF(NEXCRG.GT.0) THEN
       DO  IEXC=1,NEXCRG
        if(iconstep.eq.1) then
        NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
        NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
        else
         call locate(npts,txv,alow(IEXC),nptlow)
         call locate(npts,txv,ahigh(IEXC),npthi)
        endif
        IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 10
       end do
      END IF
      cou1=Y(I)/VAR(I)
      if(cou1.lt.0.0001) cou1=1.0
      coun=Y(I)*cou1
      if(cou1.lt.0.0001) then
      del=0.0
       else
      DEL=ABS(Y(I)-float(genpoi(coun))/cou1)
       endif
      Ss1=Ss1+DEL
      if(i.le.iquar) then
       sumyy1=sumyy1+y(i)-YC(i)
      elseif(i.gt.iquar.and.i.le.2*iquar) then
       sumyy2=sumyy2+y(i)-YC(i)
      elseif(i.gt.2*iquar.and.i.le.3*iquar) then
       sumyy3=sumyy3+y(i)-YC(i)
      else
       sumyy4=sumyy4+y(i)-YC(i)
      endif
   10 CONTINUE
      sumyy=sumyy1+sumyy2+sumyy3+sumyy4
      EXRP= 100.0*Ss1/D1
      EXcRP= 100.0*Ss1/QQ1
c
c  Calculate the number of refined parameters as a function of its class
c  INTDP(K),NPRFP(K),NGLB
c
      NGLB=0
      Nprft=0
      indpt=0
      DO K=1,NPHASE
       INTDP(K)=0
       NPRFP(K)=0
        nreph(k)=0
        do i=1,3
         refeff(k,i)=0.0
        end do
      END DO
      iprefo=0

      DO 330 I=1,MAXS
      itpar(i)=0
      ibad(i)=0
C
        DO J =1,NGL
          IF (I.EQ.LGLB(J)) THEN
           NGLB=NGLB+1
           itpar(i)=1
           GO TO 330
          ENDIF
        End Do
C
      IOF=0
        DO K=1,NPHASE
        IF(K.GT.1) IOF=IOF+NATOM(K-1)
          DO J=1,MPAR
            IF(I.EQ.LPAR(K,J)) THEN
             if(j.gt.11.and.j.lt.14) then
              INTDP(K)=INTDP(K)+1
              indpt=indpt+1
              itpar(i)=4
              iprefo=1
              goto 330
             else
              NPRFP(K)=NPRFP(K)+1
              nprft=nprft+1
              itpar(i)=2
              GOTO 330
             endif
            ENDIF
          End Do

          DO L=1,NVK(K)
            DO J=1,3
              IF(I.EQ.LVK(K,L,J)) THEN
               NPRFP(K)=NPRFP(K)+1
               nprft=nprft+1
               itpar(i)=3
               GOTO 330
              ENDIF
            End Do
          End Do
        DO KK=1,NATOM(K)
          DO J=1,nat_p
            IF(I.EQ.LP(IOF+KK,J)) THEN
            INTDP(K)=INTDP(K)+1
            indpt=indpt+1
            itpar(i)=4
            GO TO 330
            ENDIF
          End Do
        End Do

      End Do     !PHASE K
  330 CONTINUE
c
c  Check correlated parameters
c
      do i=1,maxs
       ni=0
        DO J =1,NGL
          IF (I.EQ.LGLB(J)) THEN
           ni=ni+1
           if(itpar(i).ne.1) ibad(i)=ibad(i)+1
          ENDIF
        End Do
C
      IOF=0
        DO K=1,NPHASE
        IF(K.GT.1) IOF=IOF+NATOM(K-1)
          DO J=1,MPAR
            IF(I.EQ.LPAR(K,J)) THEN
             if(j.gt.11.and.j.lt.14) then
             ni=ni+1
             if(itpar(i).ne.4) ibad(i)=ibad(i)+1
              else
             ni=ni+1
             if(itpar(i).ne.2) ibad(i)=ibad(i)+1
              endif
            ENDIF
          End Do

          DO L=1,NVK(K)
            DO J=1,3
              IF(I.EQ.LVK(K,L,J)) THEN
               Ni=ni+1
               if(itpar(i).ne.3) ibad(i)=ibad(i)+1
              ENDIF
            End Do
          End Do
        DO KK=1,NATOM(K)
          DO J=1,nat_p
            IF(I.EQ.LP(IOF+KK,J)) THEN
               Ni=ni+1
               if(itpar(i).ne.4) ibad(i)=ibad(i)+1
            ENDIF
          End Do

        End Do
      End Do     !PHASE K
      niap(i)=ni
      end do
c
c  Check preferred orientation parameters
c
      do k=1,nphase
      end do
C
C  Calculation of the effective number of reflections
C
      zer=GLB(1)
      c100=0.0
      c50 =0.0
      c25 =0.0
      nreftot=0
      ipass=0
      fwhmav=0.0
c-------------------------------------------------------------
      DO 481 I=1,ICZ        !Main loop over reflections
c-------------------------------------------------------------
      TWTET=REFS(I,2)
      if(ixunit.eq.1) then
       SHIFT =dtt2*(twtet/dtt1)**2
      else
       SHIFT =GLB(8)*COSD(TWTET/2.)+GLB(9)*SIND(TWTET)
      endif
      tt=TWTET+SHIFT+ZER
      W_DT=WDT*RMUT*REFS(I,1)
      DO 485 J=1,NEXCRG
        IF(tt.GE.(ALOW(J)-W_DT).AND.tt.LE.(AHIGH(J)+W_DT)) GOTO 481
  485 CONTINUE
      IRC=MOD(IREFS(I)/256/256/256,8)
      if(irc.ne.1) goto 481
      ipass=ipass+1
      fwhmav=fwhmav+refs(i,1)
      if(ipass.eq.1) ifi=i
      K=IREFS(I)/256/256/256/8 !phase of the current reflection
      if(iconstep.eq.1) then
       j=(tt-THMIN)/STEP+1.5    !index of the nearest point to I
      else
       call locate(npts,txv,tt,j)
      endif
      MIN=max0(1,mod(iww(j),irs))      !Indices of contributing reflections
      MAX=min0(irs,mod(iww(j)/irs,irs))  !to the point I
      P100=Tt-REFS(I,1)        !Calculation of the intervals [P,Q]
      P50 =Tt-0.5*REFS(I,1)
      P25 =Tt-0.25*REFS(I,1)
      Q100=Tt+REFS(I,1)
      Q50 =Tt+0.5*REFS(I,1)
      Q25 =Tt+0.25*REFS(I,1)
      do m=1,nphase
       if(k.eq.m) then
        if(REFS(I,1).LT.sharp(k,1)) then
        sharp(k,1)=REFS(I,1)
        sharp(k,2)=REFS(I,2)
        endif
       endif
      end do
      rn100=0.
      rn50 =0.
      rn25 =0.
      ref100=0.
      ref50 =0.
      ref25 =0.
        do 480 m=min,max
        if(MOD(IREFS(m)/256/256/256,8).ne.1) goto 480
        km=IREFS(m)/256/256/256/8
         TW=REFS(m,2)
         if(ixunit.eq.1) then
          SHIFT =dtt2*(tw/dtt1)**2
         else
          SHIFT =GLB(8)*COSD(TW/2.)+GLB(9)*SIND(TW)
         endif
         tw=tw+shift+zer
         if(belong(tw,p100,q100)) rn100=rn100+t2o(km)
         if(belong(tw,p50 ,q50 )) rn50 =rn50 +t2o(km)
         if(belong(tw,p25 ,q25 )) rn25 =rn25 +t2o(km)
        if(km.eq.k) then
         if(belong(tw,p100,q100)) ref100=ref100+t2o(k)
         if(belong(tw,p50 ,q50 )) ref50 =ref50 +t2o(k)
         if(belong(tw,p25 ,q25 )) ref25 =ref25 +t2o(k)
        endif
 480    continue
      c100=c100+t2o(k)/amax1(rn100,1.)   ! The number of effective reflections
      c50 =c50 +t2o(k)/amax1(rn50,1.)    ! is weighted by the fraction of the phase
      c25 =c25 +t2o(k)/amax1(rn25,1.)
      refeff(k,1)=refeff(k,1)+t2o(k)/amax1(ref100,1.)
      refeff(k,2)=refeff(k,2)+t2o(k)/amax1(ref50,1.)
      refeff(k,3)=refeff(k,3)+t2o(k)/amax1(ref25,1.)
      nreph(k)=nreph(k)+1
      nreftot=nreftot+1
      ila=i
c-------------------------------------------------------------
  481 continue  !End do over reflections
c-------------------------------------------------------------
      fwhmav=fwhmav/float(ipass)
      if(iconstep.eq.1) then
       pawl= fwhmav/step
      else
       pawl= fwhmav*float(npts-1)/(Txv(npts)-txv(1))
      endif
c
c   All the calculations are finished, write the results in *.SUM file
c
      WRITE(i_sum,'(//a)') '       ------------------------------------'
      WRITE(i_sum,'(  a)') '       -    ANALYSIS OF THE REFINEMENT    -'
      WRITE(i_sum,'(a//)') '       ------------------------------------'
      WRITE(i_sum,'(a/)')   ' => GLOBAL INDICATORS:'
      WRITE(i_sum,'(a)')'    The first and last reflections appears at:'
      WRITE(i_sum,'(a,2f10.3)')
     + '  2theta(degrees)/T.O.F(microsecs) => ',refs(ifi,2),refs(ila,2)
      if(ixunit.eq.1) then
       ss1=dtt1/refs(ifi,2)
       ss2=dtt1/refs(ila,2)
      else
       ss1=2.0*sind(refs(ifi,2)/2.)/lamda(1)
       ss2=2.0*sind(refs(ila,2)/2.)/lamda(1)
      endif
      WRITE(i_sum,'(a,2f10.4)')   '    s (angstroms-1) => ',ss1,ss2
      ss1=1./ss1
      ss2=1./ss2
      WRITE(i_sum,'(a,2f10.4)')   '    D (angstroms  ) => ',ss1,ss2
      ss1=0.5/ss1
      ss2=0.5/ss2
      WRITE(i_sum,'(a,2f10.4)')   '    sin(theta/lamb) => ',ss1,ss2
      ss1=12.566371*ss1
      ss2=12.566371*ss2
      WRITE(i_sum,'(a,2f8.4/)')   '    Q (angstroms-1) => ',ss1,ss2
      WRITE(i_sum,'(2(a,f8.4))')'    The average FWHM is: ',fwhmav,
     +  '  Fwhm(av)/step = ', pawl
      pawl= sqrt(pawl)
      WRITE(i_sum,'(/a,4f9.2,a/a,f9.2/)') ' => Sum(Yiobs-Yical): ',
     +  sumyy1,sumyy2,sumyy3,sumyy4,' <- Four regions',
     +'            Total ->  ',sumyy
      WRITE(i_sum,'(a,f8.2,a,f8.2)')
     +'  Expected Rp (background uncorrected): ',exrp, ' Observed-> ',
     +Rp
      WRITE(i_sum,'(a,f8.2,a,f8.2)')
     +'  Expected cRp(background   corrected): ',excrp, ' Observed-> ',
     +cRp
      WRITE(i_sum,'(a,f8.2)')  '  -> Ratio Rp/Exp=cRp/cExp: ',Rp/exrp
      WRITE(i_sum,'(a,f8.2)')
     + '  Weighted Average Bragg R-factor: ',rbragt
      WRITE(i_sum,'(a,f8.2)') '  Weighted Average      RF-factor: ',rfav
      WRITE(i_sum,'(a,f8.2/)') '  Reduced Chi-square : ', cchi2
      WRITE(i_sum,'(a,i6)')
     +' => Total number of "independent" reflections: ',nreftot
      WRITE(i_sum,'(a/3(a,f6.1/))')
     +'    Effective number (account for resolution) of reflections: ',
     +'                      at level p=1.00  :',c100,
     +'                      at level p=0.50  :',c50 ,
     +'                      at level p=0.25  :',c25
      WRITE(i_sum,'(a/a/a//a//a/)')
     +'    A reflection contributes as x/(x+nearest), where "x"  ',
     +'   is the fraction of the total area of the current phase and ',
     +'   "nearest" is the number of adjacent reflections verifying the
     +formula:',
     +'     Postn-p*FWHM <= Postn(adjacent) <= Postn+p*FWHM ',
     +'   "nearest" is weighted by the corresponding "x(s)" '
      WRITE(i_sum,'(3(a,i6/),a)')
     +' =>             Number of global  refined parameters: ',nglb,
     +'                Number of profile refined parameters: ',nprft,
     +'    Number of intensity-dependent refined parameters: ',indpt,
     +'      (Preferred orientation belongs to this class)   '
       cop=  c25/amax1(float(indpt),1.)
       cpe=  c100/amax1(float(indpt),1.)
       cec=  c50/amax1(float(indpt),1.)
      WRITE(i_sum,'(/a,3(/a,f6.1))')
     +' => (Effective Number of reflections)/(Number of intensity parame
     +ters)= Refni',
     +'      Ratio ( Optimistic view,p=0.25): ',cop,
     +'      Ratio (Pessimistic view,p=1.00): ',cpe,
     +'      Ratio (   Eclectic view,p=0.50): ',cec
      if(jcil.ne.0) then
       WRITE(i_rpa,'(a,2f8.3)')   'EXRP ', exrp, rp/exrp
       WRITE(i_rpa,'(a,i5,3f8.2)')'REFL ', nreftot,c100,c50,c25
       WRITE(i_rpa,'(a,3i5)')'REFP ', nglb,nprft,indpt
       WRITE(i_rpa,'(a,3f8.2)')'SOLV ', cpe,cec,cop
      endif
c
c  Analysis for each phase
c

      WRITE(i_sum,'(/a/)')   ' => PHASE DEPENDENT INDICATORS:'
      WRITE(i_sum,'(a)')
     + ' => Positions and FWHM of the sharpest reflection'
      WRITE(i_sum,'(/a/)')
     + '     Phase  2Theta/TOF  FWHM     Q       DQ      Delta '
      do k=1,nphase
      if(ixunit.eq.1) then
       ss1=12.566371*dtt1/sharp(k,2)
       ss2=12.566371*dtt1*sharp(k,1)/sharp(k,2)
      else
       ss1=12.566371*sind(sharp(k,2)/2.)/lamda(1)  !4pi
       ss2=0.1096622*sharp(k,1)*cosd(sharp(k,2)/2.)/lamda(1)  !2pi*pi/180
      endif
       del=19.739209*mltg(k)/(ss1*ss1*Volum(k))
       WRITE(i_sum,'(i8,2x,f9.2,f9.4,f9.4,2f9.5)')
     +                k,sharp(k,2),sharp(k,1),ss1,ss2,del
      end do
      WRITE(i_sum,'(/a/a/)')
     +'   Q ,DQ(FWHM in Q-space) and Delta are given in 1/angstroms',
     +' Delta is the expected step between consecutive reflections at Q'
      WRITE(i_sum,'(A)')
     +' Phase    %Cont  Nintdp  Nprofp   Nref      Enref(Effective)'
      WRITE(i_sum,'(A)')
     +'                                         R:p=1  R:p=1/2  R:p=1/4'
      DO K=1,NPHASE
       WRITE(i_sum,'(1x,i5,f8.2,3i8,3f8.2)')
     + k,100.*t2o(k),intdp(k),nprfp(k) ,nreph(k),(refeff(k,j),j=1,3)
       do j=1,3
        refeff(k,j)=refeff(k,j)/amax1(float(intdp(k)),1.)
       end do
       WRITE(i_sum,'(38x,3f8.2)') (refeff(k,j),j=1,3)
      end do
      WRITE(i_sum,'(7(A/))') '  Where:',
     + '  %Cont: percentage of the total integrated intensity (100x)',
     + ' Nintdp: Number of intensity-dependent refined parameters',
     + ' Nprofp: Number of profile refined parameters',
     + '   Nref: Number "independent" contributing reflections',
     + '  Enref: Effective Number of reflections for each p-value',
     + 'R:p=1/n: Ratio Enref(Effective)/Nintdp'

      write(i_sum,'(/a/)') ' => ANALYSIS OF STANDARD DEVIATIONS'
      DO K=1,NPHASE
      do j=1,3
       refeff(k,j)=refeff(k,j)*amax1(float(intdp(k)),1.)-float(intdp(k))
       if(refeff(k,j).lt.1.0) refeff(k,j)=1.0
      end do
       WRITE(i_sum,'(a,i2,a,3f8.2)') '    Phase: ',k,
     + ' Degrees of freedom for p=1, 1/2, 1/4: ',(refeff(k,j),j=1,3)
      do j=1,3
       refeff(k,j)=sbrag(k)/refeff(k,j)
      end do
       WRITE(i_sum,'(a,a,3f8.2)') '             ',
     + ' Chi2 based on integrated intensities: ',(refeff(k,j),j=1,3)
      end do
      rnumer=es2+float(-Num1+nglb+nprft)
      ch100=abs(1.0+rnumer/(c100-float(indpt)))
      ch50 =abs(1.0+rnumer/(c50 -float(indpt)))
      ch25 =abs(1.0+rnumer/(c25 -float(indpt)))
       WRITE(i_sum,'(a,a,3f8.2)') '             ',
     + ' Calculated with Scott''s formula     : ',  ch100,ch50,ch25

      write(i_sum,'(/a/a/a/a)')
     +' => Standard deviations concern the PRECISION of parameters and',
     +'    represent ACCURACY only if there is no systematic errors',
     +'    A better estimate of the accuracy of structural parameters',
     +'    is obtained multiplying sigmas by the parameter SCOR'
      write(i_sum,'(a,f8.4,a)')' -> SCOR = ',SCOR,' { Berar''s formula}'
      write(i_sum,'(a,f8.4,a)')' -> SCOR = ',pawl,' {Pawley''s formula}'
      if(jcil.ne.0) then
       WRITE(i_rpa,'(a,f10.4)')'SCOR ',SCOR
      endif
      write(i_sum,'(a)')' -> Application of modified Scott''s formula'
      do k=1,NPHASE
       do j=1,3
        refeff(k,j)=sqrt(refeff(k,j)/cChi2)
       end do
      write(i_sum,'(a,3f8.4)')'    SCOR(p=1,1/2,1/4) = ',
     +       (refeff(k,j),j=1,3)
      if(jcil.ne.0) then
       WRITE(i_rpa,'(a,i1,2x,3f8.2)')'SCOR',k,(refeff(k,j),j=1,3)
      endif
      end do
      write(i_sum,'(a,3f8.4)')'    SCOR(expected Si) = ',
     +   sqrt(ch100/cchi2), sqrt(ch50/cchi2),sqrt(ch25/cchi2)
      write(i_sum,'(a/a)')
     +'   Warning! Do not take into account Scott''s SCOR',
     +'            These indicators are under test....'
c
c  Correlated parameters
c
      WRITE(i_sum,'(/A/)') ' => ANALYSIS OF CORRELATED PARAMETERS '
      ic0=0
       do i=1,maxs
        if (niap(i).gt.1) then
        ic0=ic0+1
        WRITE(i_sum,'(a,i4,a,i4,a)')
     +'  -> The parameter: ',i,' appears',niap(i), ' times'
        endif
       end do
        WRITE(i_sum,'(a,i4/)')
     +'  -> The number of correlated parameters is :',ic0

c
c  Warning messages
c
      iwar=0
      igood=0
      iest=0
      do i=1,maxs
        if(ibad(i).gt.0) then
        WRITE(i_sum,'(a,i4,a)')
     +' => WARNING!!!  Parameter: ',i,' -> correlation of distinct kind'
        iwar=iwar+4
        endif
      end do
      if(cchi2.lt.0.9) then
      WRITE(i_sum,'(a/a/a/a)') ' => WARNING!:',
     +'  Reduced Chi-square  TOO LOW, probably the standard deviations',
     +'  of the data are not correct and/or you are using an excessive',
     +'  number of parameters'
      iwar=iwar+1
      endif
      if(iprefo.eq.1.and.iabs(jobtyp).eq.1) then
      WRITE(i_sum,'(a/a)') ' => WARNING!:',
     +'  Are you really dealing with a preferred orientation problem?'
      iwar=iwar+1
      endif

      if(cchi2.gt.10.0) then

       if(rbragt.lt.8.0) then
      WRITE(i_sum,'(a/a/a)') ' => WARNING!:',
     +'  Reduced Chi-square  TOO HIGH, the model is probably good but',
     +'  the residuals are dominated by systematic errors in profile.'
       if(rbragt.gt.5.0) WRITE(i_sum,'(a)')
     +     '  Try to improve the peak shape model!'
        else
      WRITE(i_sum,'(a/a/a)') ' => WARNING!:',
     +'  Reduced Chi-square and average R-Bragg are TOO HIGH',
     *'  the model should be improved  '
      iwar=iwar+1
       endif

       else    ! cChi2 <10.0

       if(rbragt.lt.8.0) then
       igood=1
       if(rbragt.lt.5.0.and.cchi2.gt.3.) igood=5
       if(rbragt.lt.5.0.and.cchi2.lt.3.) igood=10
        else
       iest=1
       if(rbragt.lt.15.0.and.cchi2.lt.3.) iest=5
        endif
      endif
      if(cec.lt.4.) then
      WRITE(i_sum,'(a/a)') ' => WARNING!:',
     +'  Eclectic-view-ratio is TOO LOW (<4), if there is no constraint'
     +,'  your intensity-dependent parameters could be rather inaccurate
     +!'
      iwar=iwar+1
      endif
      if(iwar.ge.4)
     + WRITE(i_sum,'(a)')
     +  ' => Please, check carefully what are you doing!'
      if(iwar.lt.2.and.igood.eq.1)
     + WRITE(i_sum,'(a)') ' => Your refinement could still be improved!'
      if(iwar.lt.2.and.igood.eq.5)
     + WRITE(i_sum,'(a)') ' => Your refinement seems to be rather good!'
      if(iwar.lt.1.and.igood.eq.10)
     + WRITE(i_sum,'(a)') ' => Your refinement seems to be very good!'
      if(iwar.lt.2.and.iest.eq.1)
     + WRITE(i_sum,'(a/a)')
     +' => Your Chi-square is NOT HIGH but the model could be improved',
     +'    if the statistic is good enough!'
      if(iwar.lt.2.and.iest.eq.5)
     + WRITE(i_sum,'(a/a)')
     +' => Chi-square is LOW but the HIGH R-Bragg factor can be due to',
     +'    a bad structural model and/or a rather poor statistic'
c
c End of warning messages
c
      RETURN
      END
